import { ColumnDropdownCellOverlayEvents } from '../dropdown/columnDropdown/cellOverlay/columnDropdownCellOverlayEvents';
import { RowDropdownCellOverlayEvents } from '../dropdown/rowDropdown/cellOverlay/rowDropdownCellOverlayEvents';
import { EditableHeaderCellEvents } from './headerCell/editable/editableHeaderCellEvents';
import { DateCellEvents } from './cellsWithTextDiv/dateCell/dateCellEvents';
import { CheckboxCellEvents } from './checkboxCell/checkboxCellEvents';
import { SelectCell } from './cellsWithTextDiv/selectCell/selectCell';
import { HeaderCellEvents } from './headerCell/headerCellEvents';
import { DataCellEvents } from './dataCell/dataCellEvents';
export class CellEventsReset {
    static unset(cellElement) {
        cellElement.onfocus = () => { };
        cellElement.onblur = () => { };
        cellElement.onmouseenter = () => { };
        cellElement.onmouseleave = () => { };
        cellElement.onmousedown = () => { };
        cellElement.oninput = () => { };
        cellElement.onpaste = () => { };
        cellElement.onkeydown = () => { };
    }
    static setDataCellEvents(at, cellElement, rowIndex, columnIndex) {
        const { settings, activeType } = at._columnsDetails[columnIndex];
        if (!settings.isCellTextEditable)
            return;
        DataCellEvents.setEvents(at, cellElement, rowIndex, columnIndex);
        const { cellDropdownProps, calendar, checkbox } = activeType;
        if (cellDropdownProps) {
            SelectCell.setEvents(at, cellElement, rowIndex, columnIndex);
        }
        else if (calendar) {
            DateCellEvents.setEvents(at, cellElement, rowIndex, columnIndex);
        }
        else if (checkbox) {
            CheckboxCellEvents.setEvents(at, cellElement, rowIndex, columnIndex);
        }
    }
    static setHeaderCellEvents(at, cellElement, rowIndex, columnIndex) {
        var _a, _b, _c;
        if ((_c = (_b = (_a = at._defaultColumnsSettings.columnDropdown) === null || _a === void 0 ? void 0 : _a.displaySettings) === null || _b === void 0 ? void 0 : _b.openMethod) === null || _c === void 0 ? void 0 : _c.cellClick) {
            HeaderCellEvents.setEvents(at, cellElement, columnIndex);
        }
        else {
            DataCellEvents.setEvents(at, cellElement, rowIndex, columnIndex);
            EditableHeaderCellEvents.setEvents(at, cellElement, 0, columnIndex);
            ColumnDropdownCellOverlayEvents.setEvents(at, columnIndex);
        }
    }
    // REF-33
    static reset(at, cellElement, rowIndex, columnIndex) {
        if (rowIndex === 0) {
            CellEventsReset.setHeaderCellEvents(at, cellElement, rowIndex, columnIndex);
        }
        else {
            CellEventsReset.setDataCellEvents(at, cellElement, rowIndex, columnIndex);
        }
        if (!at._frameComponents.displayIndexColumn && columnIndex === 0) {
            RowDropdownCellOverlayEvents.addCellEvents(at, rowIndex, cellElement);
        }
    }
}
//# sourceMappingURL=cellEventsReset.js.map