import { ConvertCellTypeUtils } from '../../../../utils/columnType/convertCellTypeUtils';
import { CellStructureUtils } from '../../../../utils/columnType/cellStructureUtils';
import { DateCellInputElement } from './dateCellInputElement';
import { DateCellTextElement } from './dateCellTextElement';
import { Browser } from '../../../../utils/browser/browser';
import { DateCellEvents } from './dateCellEvents';
// a cell becomes a date when it uses a calendar
export class DateCellElement {
    // prettier-ignore
    static setCellDateStructure(at, cellElement, columnIndex) {
        ConvertCellTypeUtils.preprocessCell(cellElement);
        cellElement.style.cursor = 'text';
        const { isCellTextEditable } = at._columnsDetails[columnIndex].settings;
        const textElement = DateCellTextElement.setCellTextAsAnElement(cellElement, isCellTextEditable);
        if (Browser.IS_INPUT_DATE_SUPPORTED)
            DateCellInputElement.addDateInputElement(cellElement, textElement, at._columnsDetails[columnIndex].activeType);
    }
    static setColumnDateStructure(at, columnIndex) {
        CellStructureUtils.setColumn(at, columnIndex, DateCellElement.setCellDateStructure, DateCellEvents.setEvents);
    }
}
//# sourceMappingURL=dateCellElement.js.map