import { RegexUtils } from '../../../../utils/regex/regexUtils';
import { CellTextElement } from '../text/cellTextElement';
export class DateCellTextElement {
    static convertInputValueToText(inputDate, defaultText, calendarFunc) {
        const integerArr = RegexUtils.extractIntegerStrs(inputDate);
        // null when the user clicks on clear button on the calendar
        if (integerArr) {
            return calendarFunc.fromYMDFunc(integerArr);
        }
        return defaultText;
    }
    static setCellTextAsAnElement(cellElement, isCellTextEditable) {
        const textElement = CellTextElement.setCellTextAsAnElement(cellElement, isCellTextEditable);
        textElement.style.float = 'left';
        return textElement;
    }
}
//# sourceMappingURL=dateCellTextElement.js.map