import { KEYBOARD_KEY } from '../../../../consts/keyboardKeys';
import { DataCellEvents } from '../../dataCell/dataCellEvents';
import { DateCellInputElement } from './dateCellInputElement';
import { Browser } from '../../../../utils/browser/browser';
import { CellWithTextEvents } from '../cellWithTextEvents';
import { CellTextEvents } from '../text/cellTextEvents';
import { CellElement } from '../../cellElement';
export class DateCellTextEvents {
    static keyDownOnText(rowIndex, columnIndex, event) {
        if (event.key === KEYBOARD_KEY.TAB)
            CellTextEvents.tabOutOfCell(this, rowIndex, columnIndex, event);
    }
    static inputText(columnIndex, event) {
        if (Browser.IS_INPUT_DATE_SUPPORTED) {
            const { activeType } = this._columnsDetails[columnIndex];
            const cellElement = CellElement.getCellElement(event.target);
            DateCellInputElement.updateInputBasedOnTextDiv(cellElement, activeType);
        }
    }
    static blurText(rowIndex, columnIndex, event) {
        const textElement = event.target;
        DataCellEvents.blur(this, rowIndex, columnIndex, textElement);
    }
    static setEvents(at, textElement, rowIndex, columnIndex) {
        if (!at._columnsDetails[columnIndex].settings.isCellTextEditable)
            return;
        textElement.onfocus = CellWithTextEvents.focusText.bind(at, rowIndex, columnIndex, null);
        textElement.onblur = DateCellTextEvents.blurText.bind(at, rowIndex, columnIndex);
        textElement.oninput = DateCellTextEvents.inputText.bind(at, columnIndex);
        textElement.onkeydown = DateCellTextEvents.keyDownOnText.bind(at, rowIndex, columnIndex);
    }
}
//# sourceMappingURL=dateCellTextEvents.js.map