import { UpdateRowElement } from '../../../../../utils/insertRemoveStructure/update/updateRowElement';
import { HeaderText } from '../../../../../utils/columnDetails/headerText';
import { DataCellEvents } from '../../../dataCell/dataCellEvents';
import { KEYBOARD_KEY } from '../../../../../consts/keyboardKeys';
import { CellWithTextEvents } from '../../cellWithTextEvents';
import { CellTextEvents } from '../../text/cellTextEvents';
import { CellElement } from '../../../cellElement';
export class EditableHeaderIconTextEvents {
    static keyDownOnText(rowIndex, columnIndex, event) {
        UpdateRowElement.updateHeadRowHeightOnKeyDown(this._tableBodyElementRef);
        if (event.key === KEYBOARD_KEY.TAB)
            CellTextEvents.tabOutOfCell(this, rowIndex, columnIndex, event);
    }
    // REF-15
    static blurText(rowIndex, columnIndex, event) {
        const textElement = event.target;
        const cellElement = CellElement.getCellElement(textElement);
        HeaderText.onAttemptChange(this, cellElement, columnIndex);
        DataCellEvents.blur(this, rowIndex, columnIndex, textElement);
    }
    static setEvents(at, textElement, rowIndex, columnIndex) {
        if (!at._columnsDetails[columnIndex].settings.isHeaderTextEditable)
            return;
        textElement.onfocus = CellWithTextEvents.focusText.bind(at, rowIndex, columnIndex, null);
        textElement.onblur = EditableHeaderIconTextEvents.blurText.bind(at, rowIndex, columnIndex);
        textElement.onkeydown = EditableHeaderIconTextEvents.keyDownOnText.bind(at, rowIndex, columnIndex);
    }
}
//# sourceMappingURL=editableHeaderIconTextEvents.js.map