import { ConvertCellTypeUtils } from '../../../../../utils/columnType/convertCellTypeUtils';
import { CellStructureUtils } from '../../../../../utils/columnType/cellStructureUtils';
import { LabelCellTextElement } from './labelCellTextElement';
import { LabelCellEvents } from './labelCellEvents';
import { CellElement } from '../../../cellElement';
import { SelectCell } from '../selectCell';
export class LabelCellElement {
    // prettier-ignore
    static setCellLabelStructure(at, cellElement, columnIndex) {
        var _a;
        ConvertCellTypeUtils.preprocessCell(cellElement);
        const { cellDropdown: { itemsDetails }, settings: { isCellTextEditable } } = at._columnsDetails[columnIndex];
        const backgroundColor = ((_a = itemsDetails[CellElement.getText(cellElement)]) === null || _a === void 0 ? void 0 : _a.backgroundColor) || '';
        LabelCellTextElement.setCellTextAsAnElement(cellElement, backgroundColor, isCellTextEditable);
        SelectCell.setPointerCursorIfCantAdd(cellElement, at._columnsDetails[columnIndex].activeType);
    }
    static setColumnLabelStructure(at, columnIndex) {
        CellStructureUtils.setColumn(at, columnIndex, LabelCellElement.setCellLabelStructure, LabelCellEvents.setEvents);
    }
}
//# sourceMappingURL=labelCellElement.js.map