import { SelectCellTextBaseEvents } from '../baseEvents/selectCellTextBaseEvents';
import { SelectCellBaseEvents } from '../baseEvents/selectCellBaseEvents';
import { CellWithTextEvents } from '../../cellWithTextEvents';
export class LabelCellEvents {
    static setEvents(at, cellElement, rowIndex, columnIndex) {
        if (!at._columnsDetails[columnIndex].settings.isCellTextEditable)
            return;
        // important to note that this is still using data events that have not be overwritten here
        // onblur/onfocus do not work for firefox, hence using textElement and keeping it consistent across browsers
        cellElement.onblur = () => { };
        cellElement.onfocus = () => { };
        cellElement.onmouseenter = () => { };
        cellElement.onmouseleave = () => { };
        cellElement.onmousedown = CellWithTextEvents.mouseDown.bind(at, SelectCellBaseEvents.blurIfDropdownFocused);
        const textElement = cellElement.children[0];
        SelectCellTextBaseEvents.setEvents(at, textElement, rowIndex, columnIndex);
    }
}
//# sourceMappingURL=labelCellEvents.js.map