import { CellDropdownItem } from '../../../../dropdown/cellDropdown/cellDropdownItem';
import { CellTextElement } from '../../text/cellTextElement';
import { EMPTY_STRING } from '../../../../../consts/text';
import { CellElement } from '../../../cellElement';
export class LabelCellTextElement {
    static isLabelText(element) {
        return element.classList.contains(LabelCellTextElement.TEXT_CLASS);
    }
    static setCellTextAsAnElement(cellElement, backgroundColor, isCellTextEditable) {
        const textElement = CellTextElement.setCellTextAsAnElement(cellElement, isCellTextEditable);
        textElement.classList.add(LabelCellTextElement.TEXT_CLASS);
        textElement.style.backgroundColor = backgroundColor;
    }
    // prettier-ignore
    static finaliseEditedText(at, textElement, columnIndex, processMatching = false) {
        var _a;
        const columnDetails = at._columnsDetails[columnIndex];
        const { cellDropdown, activeType: { cellDropdownProps }, settings: { defaultText, isDefaultTextRemovable } } = columnDetails;
        const color = (_a = cellDropdown.itemsDetails[CellElement.getText(textElement)]) === null || _a === void 0 ? void 0 : _a.backgroundColor;
        if (CellElement.getText(textElement) === EMPTY_STRING
            || (isDefaultTextRemovable && CellElement.getText(textElement) === defaultText)) {
            textElement.style.backgroundColor = '';
        }
        else if (processMatching && color) {
            textElement.style.backgroundColor = color;
            // not using staticItems state as this method may be called before it is available, if not, then refactor
        }
        else if (cellDropdownProps === null || cellDropdownProps === void 0 ? void 0 : cellDropdownProps.canAddMoreOptions) {
            // if a label is deleted and then added with an already existing text element, use its current background
            CellDropdownItem.addNewItem(at, textElement, columnDetails, textElement.style.backgroundColor);
        }
    }
}
LabelCellTextElement.TEXT_CLASS = 'label-cell-text';
//# sourceMappingURL=labelCellTextElement.js.map