import { SelectCellTextBaseEvents } from '../baseEvents/selectCellTextBaseEvents';
import { SelectCellBaseEvents } from '../baseEvents/selectCellBaseEvents';
import { ArrowDownIconElement } from './arrowDownIconElement';
import { CellWithTextEvents } from '../../cellWithTextEvents';
import { Dropdown } from '../../../../dropdown/dropdown';
import { CellElement } from '../../../cellElement';
export class SelectCellEvents {
    static mouseLeaveCell(columnIndex, event) {
        delete this._hoveredElements.selectCell;
        const cellElement = event.target;
        const { cellDropdown } = this._columnsDetails[columnIndex];
        if (!Dropdown.isDisplayed(cellDropdown.element) || cellDropdown.displayedCellElement !== cellElement) {
            ArrowDownIconElement.toggle(cellElement, false);
        }
    }
    static mouseEnterCell(event) {
        this._hoveredElements.selectCell = event.target;
        ArrowDownIconElement.toggle(this._hoveredElements.selectCell, true);
    }
    static mouseDownCell(event) {
        var _a;
        const targetElement = event.target;
        if (targetElement.classList.contains(CellElement.CELL_CLASS)) {
            CellWithTextEvents.mouseDownCell(this, SelectCellBaseEvents.blurIfDropdownFocused, targetElement, event);
        }
        else if (targetElement.classList.contains(ArrowDownIconElement.ARROW_ICON_CLASS)) {
            const cellElement = (_a = targetElement.parentElement) === null || _a === void 0 ? void 0 : _a.parentElement;
            CellWithTextEvents.mouseDownCell(this, SelectCellBaseEvents.blurIfDropdownFocused, cellElement, event);
        }
    }
    static setEvents(at, cellElement, rowIndex, columnIndex) {
        if (!at._columnsDetails[columnIndex].settings.isCellTextEditable)
            return;
        // important to note that this is still using data events that have not be overwritten here
        // onblur/onfocus do not work for firefox, hence using textElement and keeping it consistent across browsers
        cellElement.onblur = () => { };
        cellElement.onfocus = () => { };
        cellElement.onmouseenter = SelectCellEvents.mouseEnterCell.bind(at);
        cellElement.onmouseleave = SelectCellEvents.mouseLeaveCell.bind(at, columnIndex);
        cellElement.onmousedown = SelectCellEvents.mouseDownCell.bind(at);
        const textElement = cellElement.children[0];
        SelectCellTextBaseEvents.setEvents(at, textElement, rowIndex, columnIndex);
    }
}
//# sourceMappingURL=selectCellEvents.js.map