import { CellDropdownItem } from '../../../../dropdown/cellDropdown/cellDropdownItem';
import { CellTextElement } from '../../text/cellTextElement';
import { EMPTY_STRING } from '../../../../../consts/text';
import { CellElement } from '../../../cellElement';
export class SelectCellTextElement {
    static setCellTextAsAnElement(at, cellElement, columnIndex) {
        const { isCellTextEditable } = at._columnsDetails[columnIndex].settings;
        const textElement = CellTextElement.setCellTextAsAnElement(cellElement, isCellTextEditable);
        textElement.classList.add(SelectCellTextElement.TEXT_CLASS);
    }
    // prettier-ignore
    static finaliseEditedText(at, textElement, columnIndex) {
        var _a, _b;
        const columnDetails = at._columnsDetails[columnIndex];
        const { cellDropdown, activeType, settings } = columnDetails;
        const text = CellElement.getText(textElement);
        const isPresent = !!((_a = cellDropdown.itemsDetails[text]) === null || _a === void 0 ? void 0 : _a.backgroundColor);
        if (((_b = activeType.cellDropdownProps) === null || _b === void 0 ? void 0 : _b.canAddMoreOptions) && text !== EMPTY_STRING && !isPresent
            && (!settings.isDefaultTextRemovable || text !== settings.defaultText)) {
            CellDropdownItem.addNewItem(at, textElement, columnDetails, textElement.style.backgroundColor);
        }
    }
}
SelectCellTextElement.TEXT_CLASS = 'select-cell-text';
//# sourceMappingURL=selectCellTextElement.js.map