import { SelectCellTextElement } from './select/selectCellTextElement';
import { LabelCellTextElement } from './label/labelCellTextElement';
import { SelectCellElement } from './select/selectCellElement';
import { SelectCellEvents } from './select/selectCellEvents';
import { LabelCellElement } from './label/labelCellElement';
import { LabelCellEvents } from './label/labelCellEvents';
export class SelectCell {
    static convertCell(at, columnIndex, cellElement) {
        var _a;
        const columnDetails = at._columnsDetails[columnIndex];
        if ((_a = columnDetails.activeType.cellDropdownProps) === null || _a === void 0 ? void 0 : _a.isBasicSelect) {
            SelectCellElement.setCellSelectStructure(at, cellElement, columnIndex);
        }
        else {
            LabelCellElement.setCellLabelStructure(at, cellElement, columnIndex);
        }
    }
    static convertColumn(at, columnIndex, newType) {
        var _a;
        if ((_a = newType.cellDropdownProps) === null || _a === void 0 ? void 0 : _a.isBasicSelect) {
            SelectCellElement.setColumnSelectStructure(at, columnIndex);
        }
        else {
            LabelCellElement.setColumnLabelStructure(at, columnIndex);
        }
    }
    static setEvents(at, cellElement, rowIndex, columnIndex) {
        var _a;
        const { activeType } = at._columnsDetails[columnIndex];
        if ((_a = activeType.cellDropdownProps) === null || _a === void 0 ? void 0 : _a.isBasicSelect) {
            SelectCellEvents.setEvents(at, cellElement, rowIndex, columnIndex);
        }
        else {
            LabelCellEvents.setEvents(at, cellElement, rowIndex, columnIndex);
        }
    }
    // prettier-ignore
    static finaliseEditedText(at, textElement, columnIndex, processMatching = false) {
        var _a;
        const { activeType } = at._columnsDetails[columnIndex];
        if ((_a = activeType.cellDropdownProps) === null || _a === void 0 ? void 0 : _a.isBasicSelect) {
            SelectCellTextElement.finaliseEditedText(at, textElement, columnIndex);
        }
        else {
            LabelCellTextElement.finaliseEditedText(at, textElement, columnIndex, processMatching);
        }
    }
    static setPointerCursorIfCantAdd(cellElement, activeType) {
        var _a;
        cellElement.style.cursor = 'pointer';
        if (!((_a = activeType.cellDropdownProps) === null || _a === void 0 ? void 0 : _a.canAddMoreOptions)) {
            const textElement = cellElement.children[0];
            textElement.style.caretColor = 'transparent';
            textElement.style.cursor = 'pointer';
        }
    }
}
//# sourceMappingURL=selectCell.js.map