import { CheckboxCellElement } from './checkboxCellElement';
import { CheckboxEvents } from './checkboxEvents';
import { CellElement } from '../cellElement';
export class CheckboxCellEvents {
    static mouseDownCell(event) {
        const target = event.target;
        if (target.classList.contains(CellElement.CELL_CLASS)) {
            const checkboxElement = target.children[0];
            checkboxElement.click();
        }
    }
    // REF-29
    static focusCell(event) {
        // this is triggered in firefox
        const target = event.target;
        const checkboxElement = target.children[0];
        checkboxElement.focus();
    }
    static setEvents(at, cellElement, rowIndex, columnIndex) {
        if (!at._columnsDetails[columnIndex].settings.isCellTextEditable)
            return;
        // important to note that this is still using data events that have not be overwritten here
        // onblur/onfocus do not work for firefox, hence using textElement and keeping it consistent across browsers
        cellElement.onblur = () => { };
        cellElement.onfocus = CheckboxCellEvents.focusCell;
        // these are used in date cells and overwritten when converted from
        cellElement.onmouseenter = () => { };
        cellElement.onmouseleave = () => { };
        cellElement.oninput = () => { };
        cellElement.onmousedown = CheckboxCellEvents.mouseDownCell.bind(at);
        const checkboxElement = CheckboxCellElement.getCheckboxElement(cellElement);
        CheckboxEvents.setEvents(at, checkboxElement, rowIndex, columnIndex);
    }
}
//# sourceMappingURL=checkboxCellEvents.js.map