import { FocusedCellUtils } from '../../../utils/focusedElements/focusedCellUtils';
import { KEYBOARD_KEY } from '../../../consts/keyboardKeys';
import { Browser } from '../../../utils/browser/browser';
import { CellEvents } from '../cellEvents';
export class CheckboxEvents {
    // REF-29
    static focusCheckbox(cellElement, rowIndex, columnIndex) {
        if (!Browser.IS_SAFARI)
            FocusedCellUtils.set(this._focusedElements.cell, cellElement, rowIndex, columnIndex);
    }
    // REF-29
    static blurCheckbox() {
        if (!Browser.IS_SAFARI)
            FocusedCellUtils.purge(this._focusedElements.cell);
    }
    static changeValueCheckbox(rowIndex, columnIndex, event) {
        const checkbox = event.target;
        CellEvents.updateCell(this, String(checkbox.checked), rowIndex, columnIndex, { processText: false });
    }
    static keyDownCheckbox(event) {
        if (event.key === KEYBOARD_KEY.ENTER) {
            const checkbox = event.target;
            checkbox.click();
        }
    }
    static setEvents(at, checkboxElement, rowIndex, columnIndex) {
        checkboxElement.onkeydown = CheckboxEvents.keyDownCheckbox;
        checkboxElement.onchange = CheckboxEvents.changeValueCheckbox.bind(at, rowIndex, columnIndex);
        checkboxElement.onfocus = CheckboxEvents.focusCheckbox.bind(at, checkboxElement, rowIndex, columnIndex);
        checkboxElement.onblur = CheckboxEvents.blurCheckbox.bind(at);
    }
}
//# sourceMappingURL=checkboxEvents.js.map