import { EditableHeaderIconTextEvents } from '../../cellsWithTextDiv/headerIconCell/editable/editableHeaderIconTextEvents';
import { FocusedCellUtils } from '../../../../utils/focusedElements/focusedCellUtils';
import { CellWithTextEvents } from '../../cellsWithTextDiv/cellWithTextEvents';
import { HeaderCellEvents } from '../headerCellEvents';
import { CellElement } from '../../cellElement';
export class EditableHeaderCellEvents {
    static mouseClickCell(columnIndex, event) {
        const cellElement = event.target;
        FocusedCellUtils.purge(this._focusedElements.cell);
        setTimeout(() => FocusedCellUtils.setHeaderCell(this._focusedElements.cell, cellElement, columnIndex));
    }
    static setEvents(at, cellElement, rowIndex, columnIndex) {
        // important to note that this is still using data cell input event
        cellElement.onmouseenter = HeaderCellEvents.mouseEnterCell.bind(at, columnIndex);
        cellElement.onmouseleave = HeaderCellEvents.mouseLeaveCell.bind(at, columnIndex);
        if (at.displayHeaderIcons) {
            cellElement.onfocus = () => { };
            cellElement.onblur = () => { };
            cellElement.onmousedown = CellWithTextEvents.mouseDown.bind(at, null);
            cellElement.onclick = EditableHeaderCellEvents.mouseClickCell.bind(at, columnIndex);
            const textElement = CellElement.getTextElement(cellElement);
            EditableHeaderIconTextEvents.setEvents(at, textElement, rowIndex, columnIndex);
        }
        else {
            cellElement.onclick = HeaderCellEvents.mouseClick.bind(at, columnIndex);
        }
    }
}
//# sourceMappingURL=editableHeaderCellEvents.js.map