import { ColumnDropdownCellOverlay } from '../../dropdown/columnDropdown/cellOverlay/columnDropdownCellOverlay';
import { FocusedCellUtils } from '../../../utils/focusedElements/focusedCellUtils';
import { ColumnSizerCellEvents } from '../../columnSizer/columnSizerCellEvents';
import { ColumnDropdown } from '../../dropdown/columnDropdown/columnDropdown';
import { CellHighlightUtils } from '../../../utils/color/cellHighlightUtils';
import { DragColumn } from '../../../utils/moveStructure/drag/dragColumn';
import { Dropdown } from '../../dropdown/dropdown';
import { CellEvents } from '../cellEvents';
export class HeaderCellEvents {
    static mouseEnterCell(columnIndex, event) {
        var _a, _b, _c, _d;
        if (!this._activeOverlayElements.selectedColumnSizer) {
            const columnDetails = this._columnsDetails[columnIndex];
            const cellElement = event.target;
            CellHighlightUtils.highlight(cellElement, (_a = columnDetails.headerStateColors) === null || _a === void 0 ? void 0 : _a.hover);
            ColumnSizerCellEvents.cellMouseEnter(this._columnsDetails, columnIndex);
            const openViaOverlayClick = (_d = (_c = (_b = this._defaultColumnsSettings.columnDropdown) === null || _b === void 0 ? void 0 : _b.displaySettings) === null || _c === void 0 ? void 0 : _c.openMethod) === null || _d === void 0 ? void 0 : _d.overlayClick;
            if (openViaOverlayClick)
                ColumnDropdownCellOverlay.display(columnDetails);
            this._hoveredElements.headerCell = cellElement;
        }
    }
    static mouseLeaveCell(columnIndex, event) {
        var _a, _b, _c, _d;
        if (!Dropdown.isDisplayed(this._activeOverlayElements.columnDropdown)) {
            CellHighlightUtils.fade(event.target, (_a = this._columnsDetails[columnIndex].headerStateColors) === null || _a === void 0 ? void 0 : _a.default);
            ColumnDropdownCellOverlay.hide(this, this._columnsDetails[columnIndex]);
            const openViaOverlayClick = (_d = (_c = (_b = this._defaultColumnsSettings.columnDropdown) === null || _b === void 0 ? void 0 : _b.displaySettings) === null || _c === void 0 ? void 0 : _c.openMethod) === null || _d === void 0 ? void 0 : _d.overlayClick;
            if (openViaOverlayClick)
                delete this._hoveredElements.headerCell;
        }
        if (!this._activeOverlayElements.selectedColumnSizer) {
            ColumnSizerCellEvents.cellMouseLeave(this._columnsDetails, columnIndex);
        }
    }
    static mouseClick(columnIndex, event) {
        var _a, _b, _c;
        const cellElement = event.target;
        CellEvents.removeTextIfDefault(this, 0, columnIndex, cellElement);
        const openViaCellClick = (_c = (_b = (_a = this._defaultColumnsSettings.columnDropdown) === null || _a === void 0 ? void 0 : _a.displaySettings) === null || _b === void 0 ? void 0 : _b.openMethod) === null || _c === void 0 ? void 0 : _c.cellClick;
        if (openViaCellClick)
            ColumnDropdown.display(this, columnIndex);
        setTimeout(() => FocusedCellUtils.setHeaderCell(this._focusedElements.cell, cellElement, columnIndex));
    }
    static setEvents(at, cellElement, columnIndex) {
        cellElement.onmouseenter = HeaderCellEvents.mouseEnterCell.bind(at, columnIndex);
        cellElement.onmouseleave = HeaderCellEvents.mouseLeaveCell.bind(at, columnIndex);
        cellElement.onclick = HeaderCellEvents.mouseClick.bind(at, columnIndex);
        DragColumn.applyEventsToElement(at, cellElement, cellElement);
    }
}
//# sourceMappingURL=headerCellEvents.js.map