import { ColumnSizerElement } from './columnSizerElement';
export class ColumnSizerCellEvents {
    static hideColumnSizer(columnSizer) {
        if (!columnSizer)
            return;
        columnSizer.isSideCellHovered = false;
        // cannot use columnSizer.isSizerHovered to identify if animation is present as it can be set to false before
        // this method is called, hence using the background image as an indicator and then checking if the sizer is
        // in fact not hovered in a timeout
        const isHovered = ColumnSizerElement.isHovered(columnSizer.element);
        setTimeout(() => {
            // check if mouse has not left the cell for the column sizer
            if (!columnSizer.isSizerHovered)
                ColumnSizerElement.hideWhenCellNotHovered(columnSizer, isHovered);
        });
    }
    static cellMouseLeave(columnsDetails, columnIndex) {
        var _a, _b;
        ColumnSizerCellEvents.hideColumnSizer((_a = columnsDetails[columnIndex - 1]) === null || _a === void 0 ? void 0 : _a.columnSizer);
        ColumnSizerCellEvents.hideColumnSizer((_b = columnsDetails[columnIndex]) === null || _b === void 0 ? void 0 : _b.columnSizer);
    }
    static displayColumnSizer(columnSizer) {
        if (!columnSizer)
            return;
        ColumnSizerElement.display(columnSizer.element);
        columnSizer.isSideCellHovered = true;
    }
    static cellMouseEnter(columnsDetails, columnIndex) {
        var _a, _b;
        ColumnSizerCellEvents.displayColumnSizer((_a = columnsDetails[columnIndex - 1]) === null || _a === void 0 ? void 0 : _a.columnSizer);
        ColumnSizerCellEvents.displayColumnSizer((_b = columnsDetails[columnIndex]) === null || _b === void 0 ? void 0 : _b.columnSizer);
    }
}
//# sourceMappingURL=columnSizerCellEvents.js.map