import { ColumnSizerT } from '../../types/columnSizer';
import { PX } from '../../types/dimensions';
export interface BorderWidths {
    leftCellRight: number;
    rightCellLeft: number;
    leftCellLeft: number;
    beforeLeftCellRight: number | undefined;
}
export declare class ColumnSizerElement {
    static readonly FILLED_BACKGROUND_IMAGE = "linear-gradient(180deg, #cdcdcd, #cdcdcd 75%, transparent 75%, transparent 100%)";
    static readonly EMPTY_BACKGROUND_IMAGE = "none";
    static readonly DEFAULT_HOVER_COLOR = "grey";
    private static readonly COLUMN_SIZER_CLASS;
    private static readonly COLUMN_SIZER_ID_PREFIX;
    static readonly TRANSITION_TIME_ML = 200;
    private static readonly TRANSITION_TIME;
    static readonly HALF_TRANSITION_TIME_ML: number;
    static isHovered(columnSizerElement: HTMLElement): boolean;
    static setBackgroundImage(columnSizerElement: HTMLElement, backgroundImage: string): void;
    static unsetBackgroundImage(columnSizerElement: HTMLElement): void;
    static setBackgroundColor(columnSizerElement: HTMLElement, color: string): void;
    static setTransitionTime(columnSizerElement: HTMLElement): void;
    static unsetTransitionTime(columnSizerElement: HTMLElement): void;
    static unsetElementsToDefault(columnSizerElement: HTMLElement, width: PX, setColors?: boolean): void;
    static setStaticProperties(columnSizerElement: HTMLElement, marginRight: string): void;
    static setElementId(columnSizerElement: HTMLElement, sizerIndex: number): void;
    static create(sizerIndex: number, hoverColor?: string): HTMLDivElement;
    static display(columnSizerElement: HTMLElement): void;
    private static hide;
    private static hideWithBlurAnimation;
    static hideWhenCellNotHovered(columnSizer: ColumnSizerT, wasHovered: boolean): void;
    static setHoverStyle(columnSizer: ColumnSizerT, width: PX, setTransition: boolean, anotherColor?: string): void;
}
//# sourceMappingURL=columnSizerElement.d.ts.map