import { ColumnSizerElement } from './columnSizerElement';
import { ColumnSizer } from './utils/columnSizer';
// REF-12
// this element is used to prevent a bug where upon hovering a column sizer that is on top of a cell border
// the cell border color (e.g. black) will still remain for a short period during the expand animation
// as the transition time causes a blend effect
// this is explicitly used to cover that color without a transition period
export class ColumnSizerFillerElement {
    static create(hoverColor) {
        const fillerElement = document.createElement('div');
        fillerElement.classList.add(ColumnSizerFillerElement.SIZER_FILLER_CLASS);
        fillerElement.style.backgroundColor = hoverColor || ColumnSizerElement.DEFAULT_HOVER_COLOR;
        fillerElement.style.display = 'none';
        return fillerElement;
    }
    static setWidth(fillerElement, width) {
        const widthNumber = Number.parseInt(width);
        fillerElement.style.width = `${ColumnSizer.shouldWidthBeIncreased(widthNumber) ? widthNumber : 4}px`;
    }
    static display(fillerElement) {
        fillerElement.style.display = 'block';
    }
    static hide(fillerElement) {
        fillerElement.style.display = 'none';
    }
}
ColumnSizerFillerElement.SIZER_FILLER_CLASS = 'column-sizer-filler';
//# sourceMappingURL=columnSizerFillerElement.js.map