import { ColumnSizerOverlayEvents } from './columnSizerOverlayEvents';
// REF-12
export class ColumnSizerOverlayElement {
    // this is recalculated as it depends on the column index that the sizer is on
    static setStaticProperties(overlayElement, marginRight, width) {
        overlayElement.style.marginRight = marginRight;
        overlayElement.style.width = width;
    }
    static applyEvents(at, columnSizer) {
        columnSizer.overlayElement.onmouseenter = ColumnSizerOverlayEvents.overlayMouseEnter.bind(at, columnSizer);
        columnSizer.overlayElement.onmouseleave = ColumnSizerOverlayEvents.overlayMouseLeave.bind(at, columnSizer);
        columnSizer.overlayElement.onmousedown = ColumnSizerOverlayEvents.overlayMouseDown.bind(at, columnSizer.element);
    }
    static create() {
        const overlayElement = document.createElement('div');
        overlayElement.classList.add(ColumnSizerOverlayElement.SIZER_OVERLAY_CLASS);
        return overlayElement;
    }
}
ColumnSizerOverlayElement.SIZER_OVERLAY_CLASS = 'column-sizer-overlay';
//# sourceMappingURL=columnSizerOverlayElement.js.map