import { RegexUtils } from '../../../utils/regex/regexUtils';
import { Browser } from '../../../utils/browser/browser';
export class ColumnSizerGenericUtils {
    // the current solution for using first row position as 'relative' with divider having 100% height only works for
    // these browsers
    static canHeightBeInherited() {
        return Browser.IS_CHROMIUM || Browser.IS_FIREFOX;
    }
    static getSizerDetailsViaElementId(id, columnsDetails) {
        const sizerNumber = Number(RegexUtils.extractIntegerStrs(id)[0]);
        const columnDetails = columnsDetails[sizerNumber];
        return { columnSizer: columnDetails.columnSizer, headerCell: columnDetails.elements[0], sizerNumber };
    }
    static findNextResizableColumnHeader(columnsDetails, sizerNumber) {
        const columnDetails = columnsDetails.slice(sizerNumber + 1).find((columnDetails) => {
            var _a;
            return !((_a = columnDetails.settings.widths) === null || _a === void 0 ? void 0 : _a.staticWidth);
        });
        return columnDetails === null || columnDetails === void 0 ? void 0 : columnDetails.elements[0];
    }
}
//# sourceMappingURL=columnSizerGenericUtils.js.map