import { OptionColorButtonEvents } from './optionColorButtonEvents';
import { Browser } from '../../../../utils/browser/browser';
import { OptionDeleteButton } from './optionDeleteButton';
import { OptionColorButton } from './optionColorButton';
export class OptionButton {
    static changeVisibility(event, dropdown, displayOnDropdown) {
        if (event.isTrusted) {
            const itemElement = event.target;
            const rightSideDelta = dropdown.scrollbarPresence.vertical ? 31 : 16;
            OptionDeleteButton.changeVisibility(itemElement, rightSideDelta, displayOnDropdown);
            if (Browser.IS_COLOR_PICKER_SUPPORTED && dropdown.labelDetails && !dropdown.labelDetails.colorPickerContainer) {
                OptionColorButton.changeVisibility(itemElement, rightSideDelta + 18, displayOnDropdown);
            }
        }
    }
    // prettier-ignore
    static hideAfterColorPickerContainerClose(columnsDetails, columnDetails) {
        const { cellDropdown: { labelDetails } } = columnDetails;
        if (labelDetails === null || labelDetails === void 0 ? void 0 : labelDetails.colorPickerContainer) {
            labelDetails.colorPickerContainer.style.display = 'none';
            const deleteButtonContainer = labelDetails.colorPickerContainer.previousElementSibling;
            deleteButtonContainer.style.display = 'none';
            delete labelDetails.colorPickerContainer;
            OptionColorButtonEvents.updateColumnLabelColors(columnsDetails, columnDetails);
        }
    }
}
OptionButton.BUTTON_CONTAINER_CLASS = 'cell-dropdown-option-button-container';
OptionButton.BUTTON_CLASS = 'cell-dropdown-option-button';
//# sourceMappingURL=optionButton.js.map