import { OptionColorButtonEvents } from './optionColorButtonEvents';
import { Browser } from '../../../../utils/browser/browser';
import { OptionButton } from './optionButton';
export class OptionColorButton {
    // buttonLevelElement is either input or button
    static extractRelativeParentElements(buttonLevelElement) {
        var _a;
        const containerElement = buttonLevelElement.parentElement;
        const textElement = (_a = containerElement.previousSibling) === null || _a === void 0 ? void 0 : _a.previousSibling;
        const dropdownItemElement = containerElement.parentElement;
        return { containerElement, textElement, dropdownItemElement };
    }
    static changeVisibility(itemElement, rightSideDelta, displayOnDropdown) {
        const buttonContainerElement = itemElement.children[2];
        buttonContainerElement.style.display = displayOnDropdown ? 'block' : 'none';
        if (displayOnDropdown) {
            const colorInputElement = buttonContainerElement.children[0];
            const leftInputDelta = Browser.IS_SAFARI ? 9 : 5;
            colorInputElement.style.left = `${displayOnDropdown.offsetWidth - rightSideDelta + leftInputDelta}px`;
            const buttonElement = buttonContainerElement.children[1];
            buttonElement.style.left = `${displayOnDropdown.offsetWidth - rightSideDelta}px`;
        }
    }
    static createIcon() {
        const iconElement = document.createElement('div');
        iconElement.innerText = OptionColorButton.COLOR_ICON_TEXT;
        iconElement.classList.add(OptionColorButton.COLOR_BUTTON_ICON_CLASS);
        return iconElement;
    }
    static createButton() {
        const buttonElement = document.createElement('div');
        buttonElement.classList.add(OptionButton.BUTTON_CLASS, OptionColorButton.COLOR_BUTTON_CLASS);
        const iconElement = OptionColorButton.createIcon();
        buttonElement.appendChild(iconElement);
        return buttonElement;
    }
    static createInput() {
        const colorInputElement = document.createElement('input');
        colorInputElement.type = 'color';
        colorInputElement.style.top = Browser.IS_SAFARI ? '0px' : '14px';
        colorInputElement.classList.add(OptionColorButton.COLOR_INPUT_CLASS);
        return colorInputElement;
    }
    static createContainer() {
        const container = document.createElement('div');
        container.classList.add(OptionButton.BUTTON_CONTAINER_CLASS);
        return container;
    }
    static create(columnsDetails, columnDetails) {
        const containerElement = OptionColorButton.createContainer();
        const colorInputElement = OptionColorButton.createInput();
        containerElement.appendChild(colorInputElement);
        const iconElement = OptionColorButton.createButton();
        containerElement.appendChild(iconElement);
        OptionColorButtonEvents.setEvents(containerElement, colorInputElement, columnsDetails, columnDetails);
        return containerElement;
    }
}
OptionColorButton.COLOR_INPUT_CLASS = 'color-input';
OptionColorButton.COLOR_BUTTON_CLASS = 'option-color-button';
OptionColorButton.COLOR_BUTTON_ICON_CLASS = 'cell-dropdown-option-color-button-icon';
OptionColorButton.COLOR_ICON_TEXT = 'c';
//# sourceMappingURL=optionColorButton.js.map