import { OptionDeleteButtonEvents } from './optionDeleteButtonEvents';
import { DropdownItem } from '../../dropdownItem';
import { OptionButton } from './optionButton';
export class OptionDeleteButton {
    static createIcon() {
        const iconElement = document.createElement('div');
        iconElement.classList.add(OptionDeleteButton.DELETE_BUTTON_ICON_CLASS);
        iconElement.innerText = OptionDeleteButton.DELETE_ICON_TEXT;
        return iconElement;
    }
    static createButton(at, columnDetails) {
        const buttonElement = document.createElement('div');
        buttonElement.classList.add(DropdownItem.DROPDOWN_ITEM_IDENTIFIER, OptionButton.BUTTON_CLASS);
        OptionDeleteButtonEvents.addEvents(at, columnDetails, buttonElement);
        return buttonElement;
    }
    static createContainer() {
        const containerElement = document.createElement('div');
        containerElement.classList.add(OptionButton.BUTTON_CONTAINER_CLASS);
        return containerElement;
    }
    static create(at, columnDetails) {
        const containerElement = OptionDeleteButton.createContainer();
        const buttonElement = OptionDeleteButton.createButton(at, columnDetails);
        const iconElement = OptionDeleteButton.createIcon();
        buttonElement.appendChild(iconElement);
        containerElement.appendChild(buttonElement);
        return containerElement;
    }
    static changeVisibility(itemElement, rightSideDelta, displayOnDropdown) {
        const buttonContainerElement = itemElement.children[1];
        buttonContainerElement.style.display = displayOnDropdown ? 'block' : 'none';
        if (displayOnDropdown) {
            const buttonElement = buttonContainerElement.children[0];
            buttonElement.style.left = `${displayOnDropdown.offsetWidth - rightSideDelta}px`;
        }
    }
}
OptionDeleteButton.DELETE_BUTTON_ICON_CLASS = 'cell-dropdown-option-delete-button-icon';
OptionDeleteButton.DELETE_ICON_TEXT = '×';
//# sourceMappingURL=optionDeleteButton.js.map