import { CellWithTextEvents } from '../../../cell/cellsWithTextDiv/cellWithTextEvents';
import { CellDropdownScrollbar } from '../cellDropdownScrollbar';
import { FireEvents } from '../../../../utils/events/fireEvents';
import { CellElement } from '../../../cell/cellElement';
export class OptionDeleteButtonEvents {
    static delete(columnDetails, event) {
        const { cellDropdown } = columnDetails;
        const buttonElement = event.target;
        const containerElement = buttonElement.parentElement;
        const itemElement = containerElement.parentElement;
        delete cellDropdown.itemsDetails[CellElement.getText(itemElement.children[0])];
        itemElement.remove();
        if (Object.keys(cellDropdown.itemsDetails).length === 0) {
            CellWithTextEvents.programmaticBlur(this);
        }
        else {
            CellDropdownScrollbar.setProperties(cellDropdown);
        }
        setTimeout(() => FireEvents.onColumnsUpdate(this));
    }
    static addEvents(at, columnDetails, buttonElement) {
        buttonElement.onclick = OptionDeleteButtonEvents.delete.bind(at, columnDetails);
    }
}
//# sourceMappingURL=optionDeleteButtonEvents.js.map