import { ScrollbarUtils } from '../../../utils/scrollbar/scrollbarUtils';
import { Dropdown } from '../dropdown';
// REF-4
export class CellDropdownHorizontalScrollFix {
    static setPropertiesIfHorizontalScrollPresent(dropdown) {
        const { element, scrollbarPresence, customDropdownStyle } = dropdown;
        // fix is only needed when both horizontal and vertical scrolls are present
        if (ScrollbarUtils.isHorizontalPresent(element) && ScrollbarUtils.isVerticalPresent(element)) {
            scrollbarPresence.horizontal = true;
            element.style.paddingBottom = CellDropdownHorizontalScrollFix.NEW_BOTTOM_PADDING_IF_PRESENT;
        }
        else {
            scrollbarPresence.horizontal = false;
            element.style.paddingBottom = (customDropdownStyle === null || customDropdownStyle === void 0 ? void 0 : customDropdownStyle.paddingBottom) || Dropdown.DROPDOWN_VERTICAL_PX;
        }
    }
    static scrollDownFurther(dropdownElement) {
        dropdownElement.scrollTop += CellDropdownHorizontalScrollFix.SCROLL_FURTHER_BOTTOM_PX;
    }
}
CellDropdownHorizontalScrollFix.NEW_BOTTOM_PADDING_IF_PRESENT = '8px';
CellDropdownHorizontalScrollFix.SCROLL_FURTHER_BOTTOM_PX = 14;
//# sourceMappingURL=cellDropdownHorizontalScrollFix.js.map