import { DragColumn } from '../../../../utils/moveStructure/drag/dragColumn';
import { DropdownCellOverlay } from '../../cellOverlay/dropdownCellOverlay';
export class ColumnDropdownCellOverlay {
    static setDefault(columnDropdownCellOverlay, overlayStyles) {
        var _a;
        columnDropdownCellOverlay.style.backgroundColor = ((_a = overlayStyles === null || overlayStyles === void 0 ? void 0 : overlayStyles.default) === null || _a === void 0 ? void 0 : _a.backgroundColor) || '';
    }
    static resetDefaultColor(columnDropdownCellOverlay, displaySettings) {
        var _a;
        const overlayStyles = displaySettings === null || displaySettings === void 0 ? void 0 : displaySettings.overlayStyles;
        if ((_a = overlayStyles === null || overlayStyles === void 0 ? void 0 : overlayStyles.hover) === null || _a === void 0 ? void 0 : _a.backgroundColor) {
            ColumnDropdownCellOverlay.setDefault(columnDropdownCellOverlay, overlayStyles);
        }
    }
    static setHoverColor(columnDetails, displaySettings) {
        var _a, _b;
        const hoverBackgroundColor = (_b = (_a = displaySettings === null || displaySettings === void 0 ? void 0 : displaySettings.overlayStyles) === null || _a === void 0 ? void 0 : _a.hover) === null || _b === void 0 ? void 0 : _b.backgroundColor;
        if (hoverBackgroundColor)
            columnDetails.columnDropdownCellOverlay.style.backgroundColor = hoverBackgroundColor;
    }
    static hide(at, columnDetails) {
        const { columnDropdownCellOverlay } = columnDetails;
        const currentHeader = at._hoveredElements.headerCell;
        setTimeout(() => {
            if (currentHeader !== at._hoveredElements.headerCell) {
                columnDropdownCellOverlay.style.height = DropdownCellOverlay.HIDDEN_PX;
            }
        });
    }
    static setHorizontalDimensions(columnDetails) {
        const { columnDropdownCellOverlay, elements } = columnDetails;
        const onePercentWidth = elements[0].offsetWidth / 100;
        columnDropdownCellOverlay.style.width = `${onePercentWidth * 50}px`;
        columnDropdownCellOverlay.style.right = `${onePercentWidth * 25}px`;
    }
    static display(columnDetails) {
        columnDetails.columnDropdownCellOverlay.style.height = DropdownCellOverlay.VISIBLE_PX;
        ColumnDropdownCellOverlay.setHorizontalDimensions(columnDetails);
    }
    static isDisplayed(columnDropdownCellOverlay) {
        return columnDropdownCellOverlay.style.height === DropdownCellOverlay.VISIBLE_PX;
    }
    static updateIfDisplayed(columnDetails) {
        if (ColumnDropdownCellOverlay.isDisplayed(columnDetails.columnDropdownCellOverlay)) {
            ColumnDropdownCellOverlay.setHorizontalDimensions(columnDetails);
        }
    }
    static create(at, headerCell, overlayStyles) {
        const columnDropdownCellOverlay = document.createElement('div');
        columnDropdownCellOverlay.classList.add(DropdownCellOverlay.DROPDOWN_CELL_OVERLAY_CLASS);
        columnDropdownCellOverlay.classList.add(ColumnDropdownCellOverlay.COLUMN_DROPDOWN_CELL_OVERLAY_CLASS);
        columnDropdownCellOverlay.style.height = DropdownCellOverlay.HIDDEN_PX;
        ColumnDropdownCellOverlay.setDefault(columnDropdownCellOverlay, overlayStyles);
        DragColumn.applyEventsToElement(at, columnDropdownCellOverlay, headerCell);
        return columnDropdownCellOverlay;
    }
    static add(at, columnIndex) {
        var _a, _b;
        const overlayStyles = (_b = (_a = at._defaultColumnsSettings.columnDropdown) === null || _a === void 0 ? void 0 : _a.displaySettings) === null || _b === void 0 ? void 0 : _b.overlayStyles;
        const headerCell = at._columnsDetails[columnIndex].elements[0];
        const columnDropdownCellOverlay = ColumnDropdownCellOverlay.create(at, headerCell, overlayStyles);
        const cellDividerElement = headerCell.nextSibling;
        cellDividerElement.appendChild(columnDropdownCellOverlay);
        return columnDropdownCellOverlay;
    }
}
ColumnDropdownCellOverlay.COLUMN_DROPDOWN_CELL_OVERLAY_CLASS = 'column-dropdown-cell-overlay';
//# sourceMappingURL=columnDropdownCellOverlay.js.map