import { FocusedCellUtils } from '../../../../utils/focusedElements/focusedCellUtils';
import { ColumnDropdownCellOverlay } from './columnDropdownCellOverlay';
import { ColumnDropdown } from '../columnDropdown';
export class ColumnDropdownCellOverlayEvents {
    static mouseClick(columnIndex, columnDetails) {
        ColumnDropdown.display(this, columnIndex);
        const headerCellElement = columnDetails.elements[0];
        setTimeout(() => FocusedCellUtils.setHeaderCell(this._focusedElements.cell, headerCellElement, columnIndex));
    }
    // prettier-ignore
    static mouseLeave(columnDetails) {
        var _a;
        ColumnDropdownCellOverlay.hide(this, columnDetails);
        delete this._hoveredElements.headerCell;
        ColumnDropdownCellOverlay.resetDefaultColor(columnDetails.columnDropdownCellOverlay, (_a = this._defaultColumnsSettings.columnDropdown) === null || _a === void 0 ? void 0 : _a.displaySettings);
    }
    static mouseEnter(columnDetails) {
        var _a;
        const headerCellElement = columnDetails.elements[0];
        this._hoveredElements.headerCell = headerCellElement;
        ColumnDropdownCellOverlay.setHoverColor(columnDetails, (_a = this._defaultColumnsSettings.columnDropdown) === null || _a === void 0 ? void 0 : _a.displaySettings);
    }
    static setEvents(at, columnIndex) {
        const columnDetails = at._columnsDetails[columnIndex];
        const { columnDropdownCellOverlay } = columnDetails;
        if (!columnDropdownCellOverlay)
            return; // can occur if pasting multiple headers and creating multiple columns
        columnDropdownCellOverlay.onmouseenter = ColumnDropdownCellOverlayEvents.mouseEnter.bind(at, columnDetails);
        columnDropdownCellOverlay.onmouseleave = ColumnDropdownCellOverlayEvents.mouseLeave.bind(at, columnDetails);
        columnDropdownCellOverlay.onclick = ColumnDropdownCellOverlayEvents.mouseClick.bind(at, columnIndex, columnDetails);
    }
}
//# sourceMappingURL=columnDropdownCellOverlayEvents.js.map