import { KEYBOARD_KEY } from '../../../consts/keyboardKeys';
import { DropdownEvents } from '../dropdownEvents';
import { ColumnDropdown } from './columnDropdown';
import { DropdownItem } from '../dropdownItem';
export class ColumnDropdownEvents {
    static focusNextColumnDropdown(at, event) {
        var _a, _b, _c;
        event.preventDefault();
        ColumnDropdown.processTextAndHide(at);
        let columnIndex = at._focusedElements.cell.columnIndex;
        if (columnIndex === at._columnsDetails.length - 1)
            columnIndex = -1;
        const columnDetails = at._columnsDetails[columnIndex + 1];
        if ((_c = (_b = (_a = at._defaultColumnsSettings.columnDropdown) === null || _a === void 0 ? void 0 : _a.displaySettings) === null || _b === void 0 ? void 0 : _b.openMethod) === null || _c === void 0 ? void 0 : _c.cellClick) {
            columnDetails.elements[0].click();
        }
        else {
            columnDetails.columnDropdownCellOverlay.click();
        }
    }
    static onKeyDown(dropdownElement, event) {
        if (event.key === KEYBOARD_KEY.ENTER) {
            const itemElement = event.target;
            if (DropdownItem.doesElementContainInputClass(itemElement)) {
                ColumnDropdown.processTextAndHide(this);
            }
            else {
                itemElement.dispatchEvent(new Event('mouseenter'));
                itemElement.dispatchEvent(new Event('click'));
            }
        }
        else if (event.key === KEYBOARD_KEY.ESCAPE) {
            ColumnDropdown.processTextAndHide(this);
        }
        else if (event.key === KEYBOARD_KEY.TAB && this._columnsDetails.length > 0) {
            ColumnDropdownEvents.focusNextColumnDropdown(this, event);
        }
        else {
            DropdownEvents.itemKeyNavigation(this.shadowRoot, dropdownElement, event);
        }
    }
    static set(at, dropdownElement) {
        dropdownElement.onkeydown = ColumnDropdownEvents.onKeyDown.bind(at, dropdownElement);
    }
}
//# sourceMappingURL=columnDropdownEvents.js.map