import { NestedDropdownItemEvents } from '../nestedDropdown/nestedDropdownItemEvents';
import { NestedDropdownItem } from '../nestedDropdown/nestedDropdownItem';
import { DropdownButtonItemConf } from '../dropdownButtonItemConf';
import { ColumnTypeDropdownItem } from './columnTypeDropdownItem';
import { NestedDropdown } from '../nestedDropdown/nestedDropdown';
import { DropdownItem } from '../dropdownItem';
export class ColumnTypeDropdown {
    static setupParentItemContent(itemElement, activeType) {
        var _a;
        const { name: activeName, dropdownItem: activeDropdownItem } = activeType;
        // setup icon
        const activeIconContainerElement = ((_a = activeDropdownItem.element) === null || _a === void 0 ? void 0 : _a.children[0]).cloneNode(true);
        itemElement.replaceChild(activeIconContainerElement, itemElement.children[0]);
        // setup text
        const textElement = itemElement.children[1];
        textElement.innerText = activeName;
    }
    static setUp(at, dropdownEl, columnIndex) {
        const { activeType, settings } = at._columnsDetails[columnIndex];
        const itemElement = dropdownEl.getElementsByClassName(ColumnTypeDropdown.COLUMN_TYPE_ITEM_CLASS)[0];
        ColumnTypeDropdown.setupParentItemContent(itemElement, activeType);
        if (settings.types.length < 2)
            return (itemElement.style.pointerEvents = 'none');
        itemElement.style.pointerEvents = '';
        setTimeout(() => ColumnTypeDropdownItem.setUp(at, columnIndex));
    }
    // prettier-ignore
    static create(at, dropdownElement) {
        const buttonElement = DropdownItem.addButtonItem(at, dropdownElement, DropdownButtonItemConf.DEFAULT_ITEM, NestedDropdownItem.NESTED_DROPDOWN_ITEM, ColumnTypeDropdown.COLUMN_TYPE_ITEM_CLASS);
        NestedDropdownItemEvents.addEvents(at, buttonElement);
        const nestedDropdown = NestedDropdown.create(); // items added every time column dropdown is opened (setUp)
        buttonElement.appendChild(nestedDropdown);
        at._activeOverlayElements.columnTypeDropdown = nestedDropdown;
    }
}
// this item is used to denote the item used to open up type dropdown
ColumnTypeDropdown.COLUMN_TYPE_ITEM_CLASS = 'dropdown-column-type-item';
//# sourceMappingURL=columnTypeDropdown.js.map