import { ColumnTypeDropdownItemEvents } from './columnTypeDropdownItemEvents';
import { SVGIconUtils } from '../../../utils/svgIcons/svgIconUtils';
import { CellElement } from '../../cell/cellElement';
import { DropdownItem } from '../dropdownItem';
export class ColumnTypeDropdownItem {
    static unsetActiveItem(dropdownElement) {
        const activeItem = dropdownElement.getElementsByClassName(DropdownItem.ACTIVE_ITEM_CLASS)[0];
        if (activeItem) {
            activeItem.children[0].style.filter = '';
            activeItem.classList.remove(DropdownItem.ACTIVE_ITEM_CLASS);
        }
    }
    static reset(dropdownElement) {
        ColumnTypeDropdownItem.unsetActiveItem(dropdownElement);
        DropdownItem.removeItems(dropdownElement);
    }
    static setActiveItem(items, targetItemText) {
        const activeItem = items.find((item) => CellElement.getText(item) === targetItemText);
        if (activeItem) {
            activeItem.classList.add(DropdownItem.ACTIVE_ITEM_CLASS);
            activeItem.children[0].style.filter = SVGIconUtils.WHITE_FILTER;
        }
    }
    // the items are repopulated every time column dropdown is opened
    static setUp(at, columnIndex) {
        const { columnTypeDropdown } = at._activeOverlayElements;
        const columnDetails = at._columnsDetails[columnIndex];
        const elements = columnDetails.settings.types.map((type) => type.dropdownItem.element);
        DropdownItem.addButtonItemElements(at, columnTypeDropdown, elements);
        ColumnTypeDropdownItemEvents.set(at, elements, columnIndex);
        ColumnTypeDropdownItem.setActiveItem(elements, columnDetails.activeType.name);
    }
}
//# sourceMappingURL=columnTypeDropdownItem.js.map