import { DropdownItemNavigation } from './dropdownItemNavigation';
import { KEYBOARD_KEY } from '../../consts/keyboardKeys';
export class DropdownEvents {
    static itemKeyNavigation(shadowRoot, dropdownElement, event) {
        if (event.key === KEYBOARD_KEY.TAB || event.key === KEYBOARD_KEY.ARROW_DOWN) {
            event.preventDefault();
            // workaround for when opened dropdown does not have a focused item
            const focusedElement = !(shadowRoot === null || shadowRoot === void 0 ? void 0 : shadowRoot.activeElement) ? dropdownElement.children[0] : event.target;
            DropdownItemNavigation.focusSiblingItem(focusedElement, dropdownElement, true);
        }
        else if (event.key === KEYBOARD_KEY.ARROW_UP) {
            DropdownItemNavigation.focusSiblingItem(event.target, dropdownElement, false);
        }
        else if (event.key === KEYBOARD_KEY.ARROW_RIGHT) {
            DropdownItemNavigation.focusFirstNestedDropdownItem(event.target);
        }
        else if (event.key === KEYBOARD_KEY.ARROW_LEFT) {
            DropdownItemNavigation.focusNestedDropdownParentItem(event.target);
        }
    }
}
//# sourceMappingURL=dropdownEvents.js.map