import { DropdownButtonItemSettings } from '../../types/dropdownButtonItem';
import { Optional } from '../../types/utilityTypes';
import { ActiveTable } from '../../activeTable';
export declare class DropdownItem {
    static readonly DROPDOWN_ITEM_CLASS = "dropdown-item";
    private static readonly DISABLED_ITEM_CLASS;
    static readonly ACTIVE_ITEM_CLASS = "active-dropdown-item";
    static readonly DROPDOWN_INPUT_CLASS = "dropdown-input";
    private static readonly DROPDOWN_ITEM_ICON_CONTAINER_CLASS;
    static readonly DROPDOWN_INPUT_ITEM_CLASS = "dropdown-input-item";
    static readonly DROPDOWN_TITLE_ITEM_CLASS = "dropdown-title-item";
    static readonly DROPDOWN_ITEM_DIVIDER_CLASS = "dropdown-item-divider";
    private static readonly DROPDOWN_ITEM_EMPTY_CLASS;
    private static readonly DROPDOWN_ITEM_EMPTY_PLACEHOLDER_TEXT;
    static readonly DROPDOWN_ITEM_IDENTIFIER = "dropdown-item-identifier";
    private static readonly HIDDEN;
    private static readonly DISPLAY;
    static toggleItem(item: HTMLElement, isDisplay: boolean): void;
    static isDisplayed(item: HTMLElement): boolean;
    private static createDropdownItemBaseElement;
    private static createItem;
    static addInputItem(at: ActiveTable, dropdownElement: HTMLElement): void;
    private static insertIcon;
    static addPlaneButtonItem(dropdownElement: HTMLElement | undefined, text: string, index?: number): HTMLElement | HTMLCanvasElement | HTMLImageElement | HTMLVideoElement | HTMLAnchorElement | HTMLScriptElement | HTMLEmbedElement | HTMLFormElement | HTMLHeadElement | HTMLAreaElement | HTMLObjectElement | HTMLLinkElement | HTMLMapElement | HTMLInputElement | HTMLBaseElement | HTMLTimeElement | HTMLDataElement | HTMLProgressElement | HTMLTrackElement | HTMLSourceElement | HTMLButtonElement | HTMLAudioElement | HTMLQuoteElement | HTMLBodyElement | HTMLBRElement | HTMLTableCaptionElement | HTMLTableColElement | HTMLDataListElement | HTMLModElement | HTMLDetailsElement | HTMLDialogElement | HTMLDivElement | HTMLDListElement | HTMLFieldSetElement | HTMLHeadingElement | HTMLHRElement | HTMLHtmlElement | HTMLIFrameElement | HTMLLabelElement | HTMLLegendElement | HTMLLIElement | HTMLMenuElement | HTMLMetaElement | HTMLMeterElement | HTMLOListElement | HTMLOptGroupElement | HTMLOptionElement | HTMLOutputElement | HTMLParagraphElement | HTMLPictureElement | HTMLPreElement | HTMLSelectElement | HTMLSlotElement | HTMLSpanElement | HTMLStyleElement | HTMLTableElement | HTMLTableSectionElement | HTMLTableCellElement | HTMLTemplateElement | HTMLTextAreaElement | HTMLTitleElement | HTMLTableRowElement | HTMLUListElement | ActiveTable;
    static createButtonItemNoEvents(dropdown: HTMLElement | undefined, itemSettings: Optional<DropdownButtonItemSettings, 'iconSettings'>, ...classNames: string[]): HTMLElement | HTMLCanvasElement | HTMLImageElement | HTMLVideoElement | HTMLAnchorElement | HTMLScriptElement | HTMLEmbedElement | HTMLFormElement | HTMLHeadElement | HTMLAreaElement | HTMLObjectElement | HTMLLinkElement | HTMLMapElement | HTMLInputElement | HTMLBaseElement | HTMLTimeElement | HTMLDataElement | HTMLProgressElement | HTMLTrackElement | HTMLSourceElement | HTMLButtonElement | HTMLAudioElement | HTMLQuoteElement | HTMLBodyElement | HTMLBRElement | HTMLTableCaptionElement | HTMLTableColElement | HTMLDataListElement | HTMLModElement | HTMLDetailsElement | HTMLDialogElement | HTMLDivElement | HTMLDListElement | HTMLFieldSetElement | HTMLHeadingElement | HTMLHRElement | HTMLHtmlElement | HTMLIFrameElement | HTMLLabelElement | HTMLLegendElement | HTMLLIElement | HTMLMenuElement | HTMLMetaElement | HTMLMeterElement | HTMLOListElement | HTMLOptGroupElement | HTMLOptionElement | HTMLOutputElement | HTMLParagraphElement | HTMLPictureElement | HTMLPreElement | HTMLSelectElement | HTMLSlotElement | HTMLSpanElement | HTMLStyleElement | HTMLTableElement | HTMLTableSectionElement | HTMLTableCellElement | HTMLTemplateElement | HTMLTextAreaElement | HTMLTitleElement | HTMLTableRowElement | HTMLUListElement | ActiveTable;
    static addTitle(dropdownElement: HTMLElement, text: string): void;
    static addDivider(dropdownElement: HTMLElement): void;
    static addButtonItem(at: ActiveTable, dropdown: HTMLElement, itemSettings: Optional<DropdownButtonItemSettings, 'iconSettings'>, ...classNames: string[]): HTMLElement | HTMLCanvasElement | HTMLImageElement | HTMLVideoElement | HTMLAnchorElement | HTMLScriptElement | HTMLEmbedElement | HTMLFormElement | HTMLHeadElement | HTMLAreaElement | HTMLObjectElement | HTMLLinkElement | HTMLMapElement | HTMLInputElement | HTMLBaseElement | HTMLTimeElement | HTMLDataElement | HTMLProgressElement | HTMLTrackElement | HTMLSourceElement | HTMLButtonElement | HTMLAudioElement | HTMLQuoteElement | HTMLBodyElement | HTMLBRElement | HTMLTableCaptionElement | HTMLTableColElement | HTMLDataListElement | HTMLModElement | HTMLDetailsElement | HTMLDialogElement | HTMLDivElement | HTMLDListElement | HTMLFieldSetElement | HTMLHeadingElement | HTMLHRElement | HTMLHtmlElement | HTMLIFrameElement | HTMLLabelElement | HTMLLegendElement | HTMLLIElement | HTMLMenuElement | HTMLMetaElement | HTMLMeterElement | HTMLOListElement | HTMLOptGroupElement | HTMLOptionElement | HTMLOutputElement | HTMLParagraphElement | HTMLPictureElement | HTMLPreElement | HTMLSelectElement | HTMLSlotElement | HTMLSpanElement | HTMLStyleElement | HTMLTableElement | HTMLTableSectionElement | HTMLTableCellElement | HTMLTemplateElement | HTMLTextAreaElement | HTMLTitleElement | HTMLTableRowElement | HTMLUListElement | ActiveTable;
    static addNewButtonItems(at: ActiveTable, dropdownElement: HTMLElement, itemsSettings: DropdownButtonItemSettings[]): HTMLElement[];
    static addButtonItemElements(at: ActiveTable, dropdownElement: HTMLElement, elements: HTMLElement[]): void;
    static removeItems(dropdown: HTMLElement): void;
    static doesElementContainItemClass(element: HTMLElement): boolean;
    static doesElementContainInputClass(element: HTMLElement): boolean;
    static getInputElement(dropdownElement: HTMLElement): Element;
    static toggleUsability(item: HTMLElement, isUsable: boolean): void;
}
//# sourceMappingURL=dropdownItem.d.ts.map