import { DropdownItemHighlightUtils } from '../../../utils/color/dropdownItemHighlightUtils';
import { NestedDropdown } from './nestedDropdown';
export class NestedDropdownItemEvents {
    // prettier-ignore
    static addEvents(at, element) {
        element.addEventListener('mouseenter', NestedDropdown.displayAndSetDropdownPosition.bind(at));
        element.addEventListener('mouseleave', NestedDropdown.hideDropdown);
        // this is required because when the user hovers over the item with mouse and then hovers over the nested dropdown,
        // upon hovering the item again - the above would not fire mouse enter as the dropdown is within the item element
        const itemContent = element.children[1];
        itemContent.addEventListener('mouseenter', DropdownItemHighlightUtils.highlightNew.bind(this, at._activeOverlayElements, element));
    }
}
//# sourceMappingURL=nestedDropdownItemEvents.js.map