import { MaximumRows } from '../../../utils/insertRemoveStructure/insert/maximum/maximumRows';
import { RowDropdownButtonItemConf } from './rowDropdownButtonItemConf';
import { RowDropdownItemEvents } from './rowDropdownItemEvents';
import { DropdownItem } from '../dropdownItem';
export class RowDropdownItem {
    static updateDeleteRowItemStyle(at, rowIndex, items) {
        DropdownItem.toggleUsability(items[4], Boolean(rowIndex > 0 || at.rowDropdown.canEditHeaderRow));
    }
    static updateMoveRowsItemsStyle(at, rowIndex, items) {
        const { isMoveAvailable, canEditHeaderRow } = at.rowDropdown;
        if (!isMoveAvailable)
            return;
        DropdownItem.toggleUsability(items[2], true);
        DropdownItem.toggleUsability(items[3], true);
        if (rowIndex === 0 || (rowIndex === 1 && !canEditHeaderRow)) {
            DropdownItem.toggleUsability(items[2], false);
        }
        if (rowIndex === at._columnsDetails[0].elements.length - 1 || (rowIndex === 0 && !canEditHeaderRow)) {
            DropdownItem.toggleUsability(items[3], false);
        }
    }
    static updateInsertRowsItemsStyle(at, rowIndex, items) {
        if (MaximumRows.canAddMore(at)) {
            if (rowIndex === 0 && !at.rowDropdown.canEditHeaderRow) {
                DropdownItem.toggleUsability(items[0], false);
            }
            else {
                DropdownItem.toggleUsability(items[0], true);
            }
            DropdownItem.toggleUsability(items[1], true);
        }
        else {
            DropdownItem.toggleUsability(items[0], false);
            DropdownItem.toggleUsability(items[1], false);
        }
    }
    static updateItemStyle(at, dropdownElement, rowIndex) {
        const items = Array.from(dropdownElement.children);
        RowDropdownItem.updateInsertRowsItemsStyle(at, rowIndex, items);
        RowDropdownItem.updateMoveRowsItemsStyle(at, rowIndex, items);
        RowDropdownItem.updateDeleteRowItemStyle(at, rowIndex, items);
    }
    static update(at, dropdownElement, rowIndex) {
        RowDropdownItem.updateItemStyle(at, dropdownElement, rowIndex);
        RowDropdownItemEvents.set(at, dropdownElement, rowIndex);
    }
    static setUpItems(at, dropdownElement) {
        // creating icons is expensive and they are not needed on initial render
        setTimeout(() => {
            const { rowDropdown } = at;
            const { isInsertUpAvailable, isInsertDownAvailable, isMoveAvailable, isDeleteAvailable } = rowDropdown;
            const items = RowDropdownButtonItemConf.ITEMS.map((item) => DropdownItem.addButtonItem(at, dropdownElement, item));
            if (!isInsertUpAvailable)
                DropdownItem.toggleItem(items[0], false);
            if (!isInsertDownAvailable)
                DropdownItem.toggleItem(items[1], false);
            if (!isMoveAvailable) {
                DropdownItem.toggleItem(items[2], false);
                DropdownItem.toggleItem(items[3], false);
            }
            if (!isDeleteAvailable)
                DropdownItem.toggleItem(items[4], false);
        });
    }
}
//# sourceMappingURL=rowDropdownItem.js.map