import { ElementSiblingIterator } from '../../../utils/elements/elementSiblingIterator';
import { InsertNewRow } from '../../../utils/insertRemoveStructure/insert/insertNewRow';
import { RemoveRow } from '../../../utils/insertRemoveStructure/remove/removeRow';
import { MoveRow } from '../../../utils/moveStructure/moveRow';
import { DropdownItem } from '../dropdownItem';
import { RowDropdown } from './rowDropdown';
export class RowDropdownItemEvents {
    static onClickMiddleware(func) {
        func();
        RowDropdown.hide(this);
    }
    // prettier-ignore
    static set(at, dropdownElement, rowIndex) {
        const firstItem = dropdownElement.getElementsByClassName(DropdownItem.DROPDOWN_ITEM_CLASS)[0];
        const siblingIterator = ElementSiblingIterator.create(firstItem);
        siblingIterator.currentElement().onclick = RowDropdownItemEvents.onClickMiddleware.bind(at, InsertNewRow.insert.bind(this, at, rowIndex, true));
        siblingIterator.next().onclick = RowDropdownItemEvents.onClickMiddleware.bind(at, InsertNewRow.insert.bind(this, at, rowIndex + 1, true));
        siblingIterator.next().onclick = RowDropdownItemEvents.onClickMiddleware.bind(at, MoveRow.move.bind(this, at, rowIndex, false));
        siblingIterator.next().onclick = RowDropdownItemEvents.onClickMiddleware.bind(at, MoveRow.move.bind(this, at, rowIndex, true));
        siblingIterator.next().onclick = RowDropdownItemEvents.onClickMiddleware.bind(at, RemoveRow.remove.bind(this, at, rowIndex));
        // TO-DO - potential animation can be useful when a row column is inserted
    }
}
//# sourceMappingURL=rowDropdownItemEvents.js.map