import { DropdownDisplaySettingsUtil } from '../dropdownDisplaySettingsUtil';
export class RowDropdownSettingsUtil {
    static postprocessOpenMethod(rowSettings, frameComponents) {
        var _a, _b;
        // when no index column and cell click method is being used, change it to overlay click
        if (!frameComponents.displayIndexColumn && ((_a = rowSettings.displaySettings.openMethod) === null || _a === void 0 ? void 0 : _a.cellClick)) {
            (_b = rowSettings.displaySettings.openMethod) === null || _b === void 0 ? true : delete _b.cellClick;
            rowSettings.displaySettings.openMethod.overlayClick = true;
        }
    }
    // prettier-ignore
    static preprocessOpenMethod(rowSettings, displaySettings) {
        if (!displaySettings)
            return;
        // if no openMethod defined and column settings has one, use its approach for open instead
        if ((rowSettings.displaySettings.openMethod === undefined
            || Object.keys(rowSettings.displaySettings.openMethod).length === 0) && displaySettings.openMethod) {
            rowSettings.displaySettings.openMethod = JSON.parse(JSON.stringify(displaySettings.openMethod));
        }
    }
    static process(at) {
        var _a, _b, _c, _d, _e, _f, _g;
        const { rowDropdown, _frameComponents, _defaultColumnsSettings } = at;
        (_a = rowDropdown.isInsertUpAvailable) !== null && _a !== void 0 ? _a : (rowDropdown.isInsertUpAvailable = true);
        (_b = rowDropdown.isInsertDownAvailable) !== null && _b !== void 0 ? _b : (rowDropdown.isInsertDownAvailable = true);
        (_c = rowDropdown.isMoveAvailable) !== null && _c !== void 0 ? _c : (rowDropdown.isMoveAvailable = true);
        (_d = rowDropdown.canEditHeaderRow) !== null && _d !== void 0 ? _d : (rowDropdown.canEditHeaderRow = true);
        (_e = rowDropdown.isDeleteAvailable) !== null && _e !== void 0 ? _e : (rowDropdown.isDeleteAvailable = true);
        (_f = rowDropdown.displaySettings) !== null && _f !== void 0 ? _f : (rowDropdown.displaySettings = {});
        RowDropdownSettingsUtil.preprocessOpenMethod(rowDropdown, (_g = _defaultColumnsSettings.columnDropdown) === null || _g === void 0 ? void 0 : _g.displaySettings);
        DropdownDisplaySettingsUtil.process(rowDropdown.displaySettings);
        RowDropdownSettingsUtil.postprocessOpenMethod(rowDropdown, _frameComponents);
    }
}
//# sourceMappingURL=rowDropdownSettingsUtil.js.map