import { SheetJSInternalUtils } from '../../../../utils/outerTableComponents/files/SheetJS/SheetJSInternalUtils';
import { SheetJSExport } from '../../../../utils/outerTableComponents/files/SheetJS/SheetJSExport';
import { CSVExport } from '../../../../utils/outerTableComponents/files/CSV/CSVExport';
import { ACCEPTED_FILE_FORMATS } from '../../../../consts/fileFormats';
export class FileExportEvents {
    static export(at, options) {
        const acceptedFormat = (options === null || options === void 0 ? void 0 : options.format) || 'csv';
        if (ACCEPTED_FILE_FORMATS.find((extension) => acceptedFormat === extension)) {
            const fileName = options === null || options === void 0 ? void 0 : options.fileName;
            if (acceptedFormat === 'csv') {
                CSVExport.export(at, fileName);
            }
            else {
                SheetJSInternalUtils.execFuncWithExtractorModule(SheetJSExport.export.bind(this, at, acceptedFormat, fileName));
            }
        }
    }
    static setEvents(at, buttonElement, options) {
        var _a;
        const singleFile = options ? { format: (_a = options.formats) === null || _a === void 0 ? void 0 : _a[0], fileName: options.fileName } : undefined;
        buttonElement.onclick = FileExportEvents.export.bind(this, at, singleFile);
    }
}
//# sourceMappingURL=fileExportEvents.js.map