import { DragAndDropEvents } from './dragAndDropEvents';
export class DragAndDropElement {
    static createOverlayElement(files) {
        const overlayElement = document.createElement('div');
        overlayElement.id = 'drag-and-drop-overlay';
        if (typeof files.dragAndDrop === 'object')
            Object.assign(overlayElement.style, files.dragAndDrop.overlayStyle);
        return overlayElement;
    }
    static append(at, fullTableContainer) {
        const overlayElement = DragAndDropElement.createOverlayElement(at.files);
        DragAndDropEvents.setEvents(at, fullTableContainer, overlayElement);
        fullTableContainer.appendChild(overlayElement);
    }
    static isEnabled(files) {
        var _a;
        if ((files === null || files === void 0 ? void 0 : files.dragAndDrop) !== undefined) {
            return !!files.dragAndDrop;
        }
        return !!((_a = files === null || files === void 0 ? void 0 : files.buttons) === null || _a === void 0 ? void 0 : _a.find((button) => button.import));
    }
}
//# sourceMappingURL=dragAndDropElement.js.map