import { ColumnDropdown } from '../dropdown/columnDropdown/columnDropdown';
import { RowDropdown } from '../dropdown/rowDropdown/rowDropdown';
import { Dropdown } from '../dropdown/dropdown';
export class FullTableOverlayEvents {
    // prettier-ignore
    static onMouseDown(event) {
        const { _activeOverlayElements: { columnDropdown, rowDropdown } } = this;
        // window events will instead handle user clicks outside of the shadow dom
        if (Dropdown.isDisplayed(columnDropdown) && !Dropdown.isPartOfDropdownElement(event.target)) {
            ColumnDropdown.processTextAndHide(this);
        }
        if (Dropdown.isDisplayed(rowDropdown)) {
            RowDropdown.hide(this);
        }
    }
}
//# sourceMappingURL=fullTableOverlayEvents.js.map