import { RowDropdownCellOverlayEvents } from '../dropdown/rowDropdown/cellOverlay/rowDropdownCellOverlayEvents';
import { FrameComponentsColors } from '../../utils/frameComponents/frameComponentsColors';
import { CellHighlightUtils } from '../../utils/color/cellHighlightUtils';
import { RowDropdown } from '../dropdown/rowDropdown/rowDropdown';
import { Dropdown } from '../dropdown/dropdown';
export class IndexColumnEvents {
    static mouseEnterCell(rowIndex, event) {
        const cellElement = event.target;
        const { cellColors } = this._frameComponents;
        const colors = FrameComponentsColors.getColorsBasedOnParam(cellColors, rowIndex);
        CellHighlightUtils.highlight(cellElement, colors.hover);
    }
    static mouseLeaveCell(rowIndex, event) {
        if (!Dropdown.isDisplayed(this._activeOverlayElements.rowDropdown)) {
            const { cellColors } = this._frameComponents;
            const colors = FrameComponentsColors.getColorsBasedOnParam(cellColors, rowIndex);
            CellHighlightUtils.fade(event.target, colors.default);
        }
    }
    static setEvents(at, cellElement, rowIndex) {
        var _a;
        cellElement.onmouseenter = IndexColumnEvents.mouseEnterCell.bind(at, rowIndex);
        cellElement.onmouseleave = IndexColumnEvents.mouseLeaveCell.bind(at, rowIndex);
        const { displaySettings, canEditHeaderRow } = at.rowDropdown;
        if (!canEditHeaderRow && rowIndex === 0)
            return;
        if (displaySettings.isAvailable && ((_a = displaySettings.openMethod) === null || _a === void 0 ? void 0 : _a.cellClick)) {
            cellElement.onclick = RowDropdown.display.bind(at, rowIndex, cellElement);
        }
        else {
            RowDropdownCellOverlayEvents.addCellEvents(at, rowIndex, cellElement);
        }
    }
}
//# sourceMappingURL=indexColumnEvents.js.map