import { OuterDropdownSimpleUtils } from '../../../../utils/outerTableComponents/dropdown/outerDropdownSimpleUtils';
import { OuterDropdownElement } from '../../../../utils/outerTableComponents/dropdown/outerDropdownElement';
import { RowsPerPageDropdownItem } from './rowsPerPageDropdownItem';
export class RowsPerPageDropdown {
    static getLeftPropertyToCenterDropdown(buttonElement, dropdownWidth) {
        const leftOffset = buttonElement.offsetLeft + buttonElement.offsetWidth / 2;
        return `${leftOffset - dropdownWidth / 2}px`;
    }
    static display(buttonElement, at, dropdown) {
        const { dropdownWidth } = at._pagination;
        const { element: dropdownElement } = dropdown;
        dropdownElement.style.left = RowsPerPageDropdown.getLeftPropertyToCenterDropdown(buttonElement, dropdownWidth);
        OuterDropdownSimpleUtils.display(buttonElement, at, dropdown);
    }
    static setWidth(dropdownElement, pagination) {
        const maxTextCharLength = pagination.rowsPerPageOptionsItemText.reduce((currrentMax, value) => {
            return isNaN(Number(value)) ? currrentMax : Math.max(currrentMax, value.length);
        }, 1);
        const textLength = maxTextCharLength * 8;
        pagination.dropdownWidth = pagination.dropdownWidth + textLength;
        dropdownElement.style.width = `${pagination.dropdownWidth}px`;
    }
    static create(at, optionsButton) {
        const hideFunc = OuterDropdownSimpleUtils.hide.bind(this, at._activeOverlayElements);
        const displayFunc = RowsPerPageDropdown.display.bind(this, optionsButton);
        // position is arbitrary as long as orientation isn't changed
        const dropdown = OuterDropdownElement.create(at, optionsButton, 'bottom-center', {}, [], hideFunc, displayFunc);
        RowsPerPageDropdownItem.populate(at, dropdown.element, optionsButton);
        RowsPerPageDropdown.setWidth(dropdown.element, at._pagination);
        return dropdown;
    }
}
//# sourceMappingURL=rowsPerPageDropdown.js.map