import { PaginationUtils } from '../../../../utils/outerTableComponents/pagination/paginationUtils';
import { RowsPerPageSelectButtonElement } from '../button/rowsPerPageSelectButtonElement';
import { PageButtonContainerElement } from '../../pageButtons/pageButtonContainerElement';
import { RowsPerPageDropdownItem } from './rowsPerPageDropdownItem';
export class RowsPerPageDropdownItemUtil {
    static updateRowsAndPaginationComponents(at, optionsButton, newRowsPerPage) {
        RowsPerPageSelectButtonElement.updateButtonText(optionsButton, newRowsPerPage);
        // when the only pagination button is disabled - changing the rows per page should not set it to active
        if (PageButtonContainerElement.shouldButtonsBeActive(at)) {
            PageButtonContainerElement.repopulateButtons(at);
            PaginationUtils.displayRowsForDifferentButton(at, 1);
        }
    }
    static getNewRowsPerPage(at, newRowsPerPage) {
        const { _pagination, content, dataStartsAtHeader } = at;
        if (_pagination.isAllRowsOptionSelected) {
            return dataStartsAtHeader ? content.length : content.length - 1;
        }
        return Number(newRowsPerPage);
    }
    static setNewRowsPerPage(at, optionsButton, newRowsPerPage) {
        at._pagination.isAllRowsOptionSelected = newRowsPerPage.toLocaleLowerCase() === RowsPerPageDropdownItem.ALL_ITEM_TEXT;
        at._pagination.rowsPerPage = RowsPerPageDropdownItemUtil.getNewRowsPerPage(at, newRowsPerPage);
        RowsPerPageDropdownItemUtil.updateRowsAndPaginationComponents(at, optionsButton, newRowsPerPage);
    }
}
//# sourceMappingURL=rowsPerPageDropdownItemUtil.js.map