import { OuterContainerElements } from '../../../utils/outerTableComponents/outerContainerElements';
import { RowsPerPageSelectButtonElement } from './button/rowsPerPageSelectButtonElement';
import { RowsPerPageDropdown } from './dropdown/rowsPerPageDropdown';
import { PaginationElements } from '../paginationElements';
export class RowsPerPageSelectElement {
    static createText(pagination) {
        var _a;
        const textElement = document.createElement('div');
        textElement.id = RowsPerPageSelectElement.TEXT_ID;
        textElement.style.marginRight = '8px';
        Object.assign(textElement.style, (_a = pagination.styles.rowsPerPageSelect) === null || _a === void 0 ? void 0 : _a.prefixText);
        textElement.innerText = pagination.rowsPerPageSelect.prefixText;
        return textElement;
    }
    static createContainer(pagination) {
        var _a;
        const rowsPerPageOptionsElement = document.createElement('div');
        rowsPerPageOptionsElement.id = RowsPerPageSelectElement.ID;
        rowsPerPageOptionsElement.classList.add(PaginationElements.PAGINATION_TEXT_COMPONENT_CLASS);
        rowsPerPageOptionsElement.style.order = String(pagination.positions.rowsPerPageSelect.order);
        Object.assign(rowsPerPageOptionsElement.style, (_a = pagination.styles.rowsPerPageSelect) === null || _a === void 0 ? void 0 : _a.container);
        return rowsPerPageOptionsElement;
    }
    // prettier-ignore
    static create(at, containers) {
        const rowsPerPageOptionsContainer = RowsPerPageSelectElement.createContainer(at._pagination);
        rowsPerPageOptionsContainer.appendChild(RowsPerPageSelectElement.createText(at._pagination));
        const optionsButton = RowsPerPageSelectButtonElement.create(at);
        const dropdown = RowsPerPageDropdown.create(at, optionsButton);
        rowsPerPageOptionsContainer.appendChild(optionsButton);
        rowsPerPageOptionsContainer.appendChild(dropdown.element);
        OuterContainerElements.addToContainer(at._pagination.positions.rowsPerPageSelect.position, containers, rowsPerPageOptionsContainer);
        return rowsPerPageOptionsContainer;
    }
}
RowsPerPageSelectElement.ID = 'pagination-number-of-rows-select';
RowsPerPageSelectElement.TEXT_ID = 'pagination-number-of-rows-select-text';
//# sourceMappingURL=rowsPerPageSelectElement.js.map