import { StatefulCSSEvents } from '../../../../utils/elements/statefulCSSEvents';
import { ElementEvents } from '../../../../utils/elements/elementEvents';
import { ElementStyle } from '../../../../utils/elements/elementStyle';
import { AddNewRowElement } from '../row/addNewRowElement';
import { RootCellElement } from './rootCellElement';
export class RootCellEvents {
    static removeEvents(addRowCellElement, rootCellEvents) {
        AddNewRowElement.setDefaultStyle(addRowCellElement);
        ElementEvents.toggleListeners(addRowCellElement, rootCellEvents.styles, false);
        addRowCellElement.dispatchEvent(new MouseEvent('mouseenter'));
        delete rootCellEvents.applied;
    }
    // setting, not apply here as this is only triggered once
    static setEventFunctions(at, addNewRowElement, styles) {
        var _a;
        if (styles) {
            at._eventFunctions.rootCell.styles = ElementEvents.convertToArrayObj(StatefulCSSEvents.getEvents(addNewRowElement, styles));
        }
        if (at._frameComponents.displayAddNewRow) {
            const convertFunction = RootCellElement.convertFromRootCell.bind(this, at);
            const { styles } = at._eventFunctions.rootCell;
            (_a = styles['click']) !== null && _a !== void 0 ? _a : (styles['click'] = []);
            styles['click'].push(convertFunction);
        }
    }
    static applyStyles(element, styles, tableElement) {
        var _a, _b, _c, _d;
        const statefulStyles = ElementStyle.generateStatefulCSS(styles, {}, {});
        // width can only be controlled via table
        // no need to unset later as adding new item will recalculate the table width
        if ((_a = statefulStyles.default) === null || _a === void 0 ? void 0 : _a.width)
            tableElement.style.width = statefulStyles.default.width;
        (_b = statefulStyles.default) === null || _b === void 0 ? true : delete _b.width;
        (_c = statefulStyles.hover) === null || _c === void 0 ? true : delete _c.width;
        (_d = statefulStyles.click) === null || _d === void 0 ? true : delete _d.width;
        Object.assign(element.style, statefulStyles.default);
    }
    // prettier-ignore
    static applyEvents(at, addNewRowElement) {
        const { _tableElementRef, rootCell, _eventFunctions: { rootCell: rootCellEvents } } = at;
        const styles = (rootCell === null || rootCell === void 0 ? void 0 : rootCell.styles) ? JSON.parse(JSON.stringify(rootCell.styles)) : null;
        if (styles && _tableElementRef)
            RootCellEvents.applyStyles(addNewRowElement, styles, _tableElementRef);
        if (Object.keys(rootCellEvents.styles).length === 0)
            RootCellEvents.setEventFunctions(at, addNewRowElement, styles);
        ElementEvents.toggleListeners(addNewRowElement, rootCellEvents.styles, true);
        rootCellEvents.applied = true;
    }
}
//# sourceMappingURL=rootCellEvents.js.map