export class TableBorderDimensionsUtils {
    static generateDefault() {
        return {
            leftWidth: 0,
            rightWidth: 0,
            topWidth: 0,
            bottomWidth: 0,
        };
    }
    static getWidth(element, cssProperty) {
        if (element.style[cssProperty] === '')
            return 1;
        return Number.parseFloat(element.style[cssProperty]) || 0;
    }
    static generateUsingElement(tableElement) {
        return {
            leftWidth: TableBorderDimensionsUtils.getWidth(tableElement, 'borderLeftWidth'),
            rightWidth: TableBorderDimensionsUtils.getWidth(tableElement, 'borderRightWidth'),
            topWidth: TableBorderDimensionsUtils.getWidth(tableElement, 'borderTopWidth'),
            bottomWidth: TableBorderDimensionsUtils.getWidth(tableElement, 'borderBottomWidth'),
        };
    }
}
//# sourceMappingURL=tableBorderDimensionsUtils.js.map