import { ARROW_DOWN_SVG_STRING } from '../../../../../consts/icons/arrowDownIconSVGString';
import { ToggleableElement } from '../../../../../utils/elements/toggleableElement';
import { SVGIconUtils } from '../../../../../utils/svgIcons/svgIconUtils';
import { FilterElements } from '../../filterElements';
// events are appended at OuterDropdownButtonEvents.set
export class FilterButtonElement {
    static create(styles = {}) {
        const button = document.createElement('div');
        button.classList.add('filter-rows-dropdown-button', ToggleableElement.AUTO_STYLING_CLASS);
        FilterElements.applyStatefulStyles(button, FilterButtonElement.HOVER_STYLE, styles);
        const svgIconElement = SVGIconUtils.createSVGElement(ARROW_DOWN_SVG_STRING);
        button.appendChild(svgIconElement);
        return button;
    }
}
FilterButtonElement.ACTIVE_STYLE = {
    filter: 
    // eslint-disable-next-line max-len
    'brightness(0) saturate(100%) invert(14%) sepia(59%) saturate(2970%) hue-rotate(219deg) brightness(98%) contrast(126%)',
};
FilterButtonElement.HOVER_STYLE = {
    filter: 
    // eslint-disable-next-line max-len
    'brightness(0) saturate(100%) invert(31%) sepia(1%) saturate(75%) hue-rotate(327deg) brightness(100%) contrast(99%)',
};
//# sourceMappingURL=filterButtonElement.js.map