import { OuterDropdownButtonEvents } from '../../../../../utils/outerTableComponents/dropdown/outerDropdownButtonEvents';
import { OuterDropdownElement } from '../../../../../utils/outerTableComponents/dropdown/outerDropdownElement';
import { FilterButtonElement } from '../button/filterButtonElement';
import { FilterDropdownItem } from './filterDropdownItem';
export class FilterDropdownElement {
    static hide(activeStyle, activeOverlayElements) {
        OuterDropdownElement.hide(activeOverlayElements, activeStyle);
    }
    // prettier-ignore
    static display(displayFunc, config, at, dropdown) {
        if (!at.content[0])
            return;
        FilterDropdownItem.populate(at, dropdown, config);
        displayFunc(at, dropdown);
    }
    // prettier-ignore
    static create(at, containerElement, position, config, dropdownArrowStyles) {
        const buttonElement = FilterButtonElement.create(dropdownArrowStyles);
        containerElement.appendChild(buttonElement);
        const customActiveStyle = (dropdownArrowStyles === null || dropdownArrowStyles === void 0 ? void 0 : dropdownArrowStyles.active) || {};
        const activeStyle = { ...FilterButtonElement.ACTIVE_STYLE, ...customActiveStyle };
        const hideFunc = FilterDropdownElement.hide.bind(this, activeStyle, at._activeOverlayElements);
        const genericDisplayFunc = OuterDropdownButtonEvents.getDisplayFunc(position);
        const displayFunc = FilterDropdownElement.display.bind(this, genericDisplayFunc, config);
        const { element } = OuterDropdownElement.create(at, buttonElement, position, activeStyle, ['filter-rows-dropdown'], hideFunc, displayFunc);
        return element;
    }
}
//# sourceMappingURL=filterDropdownElement.js.map