import { OuterDropdownItemEvents } from '../../../../../utils/outerTableComponents/dropdown/outerDropdownItemEvents';
import { FilterInternalUtils } from '../../../../../utils/outerTableComponents/filter/rows/filterInternalUtils';
import { FilterDropdownElement } from './filterDropdownElement';
export class FilterDropdownItemEvents {
    static resetInput(config, at, _, event) {
        const targetElement = event.target;
        // if clicked on text or item
        const columnIndex = targetElement.tabIndex === -1 ? targetElement.parentElement.tabIndex : targetElement.tabIndex;
        const colElements = at._columnsDetails[columnIndex].elements;
        if (colElements !== config.elements) {
            config.elements = colElements;
            FilterInternalUtils.resetInput(at, config);
            FilterInternalUtils.unsetFilter(config.inputElement);
        }
    }
    static setEvents(at, item, config, activeStyle) {
        const actionFunc = FilterDropdownItemEvents.resetInput.bind(this, config);
        const hideFunc = FilterDropdownElement.hide.bind(this, activeStyle);
        item.onmousedown = OuterDropdownItemEvents.itemMouseDownCommon.bind(at, actionFunc, hideFunc);
    }
}
//# sourceMappingURL=filterDropdownItemEvents.js.map