import { VW, VH } from '../../consts/windowDimensionPostfixes';
import { Render } from '../../utils/render/render';
export class WindowResize {
    // prettier-ignore
    static resize(observe) {
        const { _tableDimensions } = this;
        if ((observe.width && window.innerWidth !== _tableDimensions.recordedWindowWidth)
            || (observe.height && window.innerHeight !== _tableDimensions.recordedWindowHeight)) {
            Render.renderTable(this);
        }
    }
    static extractPostfix(dimension) {
        if (typeof dimension === 'string') {
            if (dimension.includes(VW))
                return VW;
            if (dimension.includes(VH))
                return VH;
        }
        return '';
    }
    static extractDimensionsToObserve(at) {
        const { tableStyle, _overflow } = at;
        const postfixes = [tableStyle.width, tableStyle.maxWidth, _overflow === null || _overflow === void 0 ? void 0 : _overflow.maxHeight, _overflow === null || _overflow === void 0 ? void 0 : _overflow.maxWidth].map((dimension) => WindowResize.extractPostfix(dimension));
        return {
            width: !!postfixes.find((entry) => entry === VW),
            height: !!postfixes.find((entry) => entry === VH),
        };
    }
    static observeIfRequired(at) {
        const dimensionsToObserve = WindowResize.extractDimensionsToObserve(at);
        if (dimensionsToObserve.width || dimensionsToObserve.height) {
            window.addEventListener('resize', WindowResize.resize.bind(at, dimensionsToObserve));
        }
    }
}
//# sourceMappingURL=windowResize.js.map