import { ColumnSettingsInternal } from './columnsSettingsInternal';
import { ColProcessedTextStyle } from './processedTextStyle';
import { ColumnTypeInternal } from './columnTypeInternal';
import { _CellDropdown } from './cellDropdownInternal';
import { CellStateColors } from './cellStateColors';
import { ColumnSizerT } from './columnSizer';
import { Optional } from './utilityTypes';
export interface BordersOverwrittenBySiblings {
    left?: boolean;
    right?: boolean;
}
export interface ColumnDetailsT {
    elements: HTMLElement[];
    processedStyle: ColProcessedTextStyle;
    columnSizer: ColumnSizerT;
    activeType: ColumnTypeInternal;
    cellDropdown: _CellDropdown;
    columnDropdownCellOverlay: HTMLElement;
    settings: ColumnSettingsInternal;
    headerStateColors: CellStateColors;
    bordersOverwrittenBySiblings: BordersOverwrittenBySiblings;
    fireColumnsUpdate: () => void;
}
export type ColumnDetailsInitial = Pick<ColumnDetailsT, 'elements' | 'processedStyle' | 'activeType' | 'cellDropdown' | 'settings' | 'headerStateColors' | 'bordersOverwrittenBySiblings' | 'fireColumnsUpdate'>;
export type ColumnDetailsNoSizer = Optional<ColumnDetailsT, 'columnSizer'>;
export type ColumnsDetailsT = ColumnDetailsT[];
//# sourceMappingURL=columnDetails.d.ts.map