import { ColumnTypeDropdownItem } from './columnTypeDropdownItem';
import { CustomTextProcessing } from './customTextProcessing';
import { LabelOptions, CellDropdownT } from './cellDropdown';
import { Calendar } from './calendarFunctionality';
import { TextValidation } from './textValidation';
import { InterfacesUnion } from './utilityTypes';
import { Sorting } from './sorting';
export type CellDropdownPropertiesI = CellDropdownT<LabelOptions> & {
    isBasicSelect: boolean;
};
export interface Parent {
    name: string;
    textValidation: TextValidation;
    customTextProcessing?: CustomTextProcessing;
    sorting?: Sorting;
    cellDropdownProps?: CellDropdownPropertiesI;
    dropdownItem: ColumnTypeDropdownItem;
}
interface CalendarT extends Omit<Parent, 'sorting'> {
    calendar: Calendar;
}
interface Checkbox extends Omit<Parent, 'sorting'> {
    checkbox: true;
}
export type ColumnTypeInternal = InterfacesUnion<CalendarT | Checkbox | Parent>;
export type ColumnTypesInternal = ColumnTypeInternal[];
export {};
//# sourceMappingURL=columnTypeInternal.d.ts.map