import { DEFAULT_COLUMN_TYPES } from '../enums/defaultColumnTypes';
import { ColumnDropdownSettings } from './columnDropdownSettings';
import { HeaderIconStyle } from './headerIconStyle';
import { HoverableStyles } from './hoverableStyles';
import { NoDimensionCSSStyle } from './cssStyle';
import { StringDimension } from './dimensions';
import { ColumnTypes } from './columnType';
import { CellText } from './tableContent';
interface Parent<CellStyle> {
    headerName: string;
    defaultText?: CellText;
    isDefaultTextRemovable?: boolean;
    cellStyle?: CellStyle;
    isCellTextEditable?: boolean;
    isColumnResizable?: boolean;
    headerStyles?: HoverableStyles;
    isHeaderTextEditable?: boolean;
    headerIconStyle?: HeaderIconStyle;
    availableDefaultColumnTypes?: DEFAULT_COLUMN_TYPES[];
    customColumnTypes?: ColumnTypes;
    defaultColumnTypeName?: string;
    columnDropdown?: ColumnDropdownSettings;
}
export type DimensionalCSSStyle = NoDimensionCSSStyle & {
    width?: StringDimension;
};
export type CustomColumnSettings<T = DimensionalCSSStyle> = Parent<T>;
export type CustomColumnsSettings = Array<CustomColumnSettings>;
export {};
//# sourceMappingURL=columnsSettings.d.ts.map