import { ColumnDropdownSettings } from './columnDropdownSettings';
import { InterfacesUnion, SetRequired } from './utilityTypes';
import { ColumnTypesInternal } from './columnTypeInternal';
import { CustomColumnSettings } from './columnsSettings';
import { NoDimensionCSSStyle } from './cssStyle';
import { StringDimension } from './dimensions';
type TransformedClientProps = Omit<SetRequired<CustomColumnSettings<NoDimensionCSSStyle>, 'defaultText' | 'isDefaultTextRemovable' | 'isCellTextEditable' | 'isHeaderTextEditable' | 'isColumnResizable'>, 'headerName'>;
export type _ColumnWidths = InterfacesUnion<{
    staticWidth: StringDimension;
} | {
    initialWidth: StringDimension;
}>;
export interface _Widths {
    widths?: _ColumnWidths;
}
export type ColumnSettingsInternal = TransformedClientProps & {
    columnDropdown: ColumnDropdownSettings;
    types: ColumnTypesInternal;
    stylePrecedence?: boolean;
} & _Widths;
export type ColumnsSettingsMap = {
    [key: string]: ColumnSettingsInternal;
};
export {};
//# sourceMappingURL=columnsSettingsInternal.d.ts.map