export class ArrayUtils {
    static transpose(array) {
        if (array.length === 0)
            return array;
        const newArray = [];
        const maxLength = Math.max(array.length, array[0].length);
        rowLoop: for (let i = 0; i < maxLength; i += 1) {
            const newRow = [];
            for (let j = 0; j < maxLength; j += 1) {
                // array[j] is undefined when array param rows are longer than their total number
                if (array[j] === undefined)
                    break;
                // array[j][i] is undefined when array param has more rows than their length - there is nothing left to transpose
                if (array[j][i] === undefined)
                    break rowLoop;
                newRow.push(array[j][i]);
            }
            newArray.push(newRow);
        }
        return newArray;
    }
    static shuffle(array) {
        return array.sort(() => Math.random() - 0.5);
    }
    static swap(array, index1, index2) {
        const temp = array[index1];
        array[index1] = array[index2];
        array[index2] = temp;
    }
}
//# sourceMappingURL=arrayUtils.js.map