import { StaticDropdown } from '../outerTableComponents/dropdown/staticDropdown';
import { DropdownItem } from '../../elements/dropdown/dropdownItem';
export class DropdownItemHighlightUtils {
    // Accepted behaviour - fadeFocused is triggered twice when moving to a different item
    static fadeCurrentlyHighlighted(activeOverlayElements) {
        const activeElement = activeOverlayElements.dropdownItem;
        if (activeElement) {
            if (activeElement.classList.contains(StaticDropdown.ACTIVE_ITEM_CLASS)) {
                activeElement.classList.remove(StaticDropdown.ACTIVE_ITEM_CLASS);
            }
            activeElement.style.backgroundColor = '';
            delete activeOverlayElements.dropdownItem;
        }
    }
    static highlightNew(activeOverlayElements, itemElement) {
        DropdownItemHighlightUtils.fadeCurrentlyHighlighted(activeOverlayElements);
        itemElement.focus();
        activeOverlayElements.dropdownItem = itemElement;
        if (itemElement.classList.contains(StaticDropdown.ITEM_CLASS)) {
            itemElement.classList.add(StaticDropdown.ACTIVE_ITEM_CLASS);
        }
        else if (!itemElement.classList.contains(DropdownItem.DROPDOWN_INPUT_CLASS)) {
            itemElement.style.backgroundColor = DropdownItemHighlightUtils.HOVER_BACKGROUND_COLOR;
        }
    }
}
DropdownItemHighlightUtils.HOVER_BACKGROUND_COLOR = '#eaeaea';
//# sourceMappingURL=dropdownItemHighlightUtils.js.map