import { CellDropdown } from '../../elements/dropdown/cellDropdown/cellDropdown';
import { ColumnTypesUtils } from '../columnType/columnTypesUtils';
// REF-13
export class ColumnDetails {
    // prettier-ignore
    static getHeaderDefaultColor(columnsSettings, key, defaultColor, settings) {
        var _a, _b, _c, _d, _e, _f;
        return ((_b = (_a = settings === null || settings === void 0 ? void 0 : settings.headerStyles) === null || _a === void 0 ? void 0 : _a.default) === null || _b === void 0 ? void 0 : _b[key]) || ((_c = settings === null || settings === void 0 ? void 0 : settings.cellStyle) === null || _c === void 0 ? void 0 : _c[key]) ||
            ((_e = (_d = columnsSettings.headerStyles) === null || _d === void 0 ? void 0 : _d.default) === null || _e === void 0 ? void 0 : _e[key]) || ((_f = columnsSettings.cellStyle) === null || _f === void 0 ? void 0 : _f[key]) || defaultColor;
    }
    // prettier-ignore
    static getHeaderHoverColor(columnsSettings, key, defaultColor, settings) {
        var _a, _b, _c, _d;
        return ((_b = (_a = settings === null || settings === void 0 ? void 0 : settings.headerStyles) === null || _a === void 0 ? void 0 : _a.hoverColors) === null || _b === void 0 ? void 0 : _b[key]) || ((_d = (_c = columnsSettings.headerStyles) === null || _c === void 0 ? void 0 : _c.hoverColors) === null || _d === void 0 ? void 0 : _d[key]) ||
            ColumnDetails.getHeaderDefaultColor(columnsSettings, key, defaultColor, settings);
    }
    // settings variable is a variable attached to columnDetails and can be either default or custom
    // prettier-ignore
    static createHeaderStateColors(columnsSettings, settings, defaultCellHoverColors) {
        return {
            hover: {
                color: ColumnDetails.getHeaderHoverColor(columnsSettings, 'color', defaultCellHoverColors['color'], settings),
                backgroundColor: ColumnDetails.getHeaderHoverColor(columnsSettings, 'backgroundColor', defaultCellHoverColors['backgroundColor'], settings),
            },
            default: {
                color: ColumnDetails.getHeaderDefaultColor(columnsSettings, 'color', '', settings),
                backgroundColor: ColumnDetails.getHeaderDefaultColor(columnsSettings, 'backgroundColor', '', settings),
            }
        };
    }
    // prettier-ignore
    static createInitial(columnsSettings, cellDropdown, settings, defaultCellHoverColors, fireColumnsUpdate) {
        const columnSettings = settings || columnsSettings;
        return {
            elements: [],
            processedStyle: [],
            settings: columnSettings,
            headerStateColors: ColumnDetails.createHeaderStateColors(columnsSettings, settings, defaultCellHoverColors),
            bordersOverwrittenBySiblings: {},
            activeType: ColumnTypesUtils.getActiveType(columnSettings),
            cellDropdown: CellDropdown.getDefaultObj(cellDropdown),
            fireColumnsUpdate,
        };
    }
    // prettier-ignore
    static updateWithNoSizer(columnDetails, columnDropdownCellOverlay) {
        const newObject = { columnDropdownCellOverlay };
        Object.assign(columnDetails, newObject);
        return columnDetails;
    }
}
ColumnDetails.MINIMAL_COLUMN_WIDTH = 34;
//# sourceMappingURL=columnDetails.js.map