export class ColumnDetailsUtils {
    static getColumnsByWidth(columnsDetails) {
        var _a;
        const dynamicWidth = [];
        const staticWidth = [];
        for (let i = 0; i < columnsDetails.length; i += 1) {
            const columnDetails = columnsDetails[i];
            if (((_a = columnDetails.settings.widths) === null || _a === void 0 ? void 0 : _a.staticWidth) !== undefined) {
                staticWidth.push(columnDetails);
            }
            else {
                dynamicWidth.push(columnDetails);
            }
        }
        return { dynamicWidth, staticWidth };
    }
    static aggregateItems(cellDropdown) {
        return cellDropdown.labelDetails
            ? Object.keys(cellDropdown.itemsDetails).map((text) => {
                return { name: text, backgroundColor: cellDropdown.itemsDetails[text].backgroundColor };
            })
            : Object.keys(cellDropdown.itemsDetails).map((text) => {
                return { name: text };
            });
    }
    static getDetails(columnDetails) {
        const updateDetails = {
            width: columnDetails.elements[0].offsetWidth,
            typeName: columnDetails.activeType.name,
        };
        if (columnDetails.activeType.cellDropdownProps) {
            updateDetails.cellDropdownItems = ColumnDetailsUtils.aggregateItems(columnDetails.cellDropdown);
        }
        return updateDetails;
    }
    static getAllColumnsDetails(columnsDetails) {
        return columnsDetails.map((columnDetails) => ColumnDetailsUtils.getDetails(columnDetails));
    }
}
//# sourceMappingURL=columnDetailsUtils.js.map