import { BordersOverwrittenBySiblings, ColumnDetailsT } from '../../types/columnDetails';
import { ActiveTable } from '../../activeTable';
type OverwritableBorderStyle = 'borderLeftWidth' | 'borderRightWidth';
export declare class ColumnSettingsBorderUtils {
    static readonly UNSET_PX = "0px";
    static overwriteSideBorderIfSiblingsHaveSettings(columnDetails: ColumnDetailsT, cellElements: HTMLElement[]): void;
    static getColumnBorderStyles(subjectBorder: keyof BordersOverwrittenBySiblings): {
        subjectBorderStyle: OverwritableBorderStyle;
        siblingBorderStyle: OverwritableBorderStyle;
    };
    static isBorderDisplayed(cell: HTMLElement, borderStyle: OverwritableBorderStyle): boolean;
    static unsetSubjectBorder(subjectElements: HTMLElement[], siblingElements: HTMLElement[], subjectBorder: keyof BordersOverwrittenBySiblings, comparisonRow: number, bordersOverwrittenBySiblings?: BordersOverwrittenBySiblings): void;
    private static unsetColumnBorder;
    private static unsetBorders;
    static resetBorderOverwritingState(currentColumn: ColumnDetailsT): void;
    private static resetIfBorderOverwritten;
    static updateSiblingColumns(at: ActiveTable, columnIndex: number): void;
}
export {};
//# sourceMappingURL=columnSettingsBorderUtils.d.ts.map