import { ColumnSettingsBorderUtils } from './columnSettingsBorderUtils';
import { CellEventsReset } from '../../elements/cell/cellEventsReset';
import { ChangeColumnType } from '../columnType/changeColumnType';
import { FireEvents } from '../events/fireEvents';
export class ResetColumnStructure {
    static reset(at, columnDetails, columnIndex) {
        const { elements, activeType, settings } = columnDetails;
        elements.slice(1).forEach((cellElement) => {
            if (!settings.isCellTextEditable)
                CellEventsReset.unset(cellElement);
        });
        ChangeColumnType.setNewStructureBasedOnType(at, columnIndex, activeType);
        ColumnSettingsBorderUtils.resetBorderOverwritingState(columnDetails);
        setTimeout(() => FireEvents.onColumnsUpdate(at));
    }
}
//# sourceMappingURL=resetColumnStructure.js.map