import { ColumnSettingsStyleUtils } from './columnSettingsStyleUtils';
import { CellElement } from '../../elements/cell/cellElement';
import { ElementStyle } from '../elements/elementStyle';
export class ResetColumnStyles {
    static applyDefaultStyles(columnElements, columnsSettings) {
        const { cellStyle, headerStyles } = columnsSettings;
        CellElement.setDefaultCellStyle(columnElements[0], cellStyle, headerStyles === null || headerStyles === void 0 ? void 0 : headerStyles.default);
        columnElements.slice(1).forEach((element) => {
            CellElement.setDefaultCellStyle(element, cellStyle);
        });
    }
    static unsetLastAppliedStyle(processedStyle, textContainerElement) {
        Object.keys(processedStyle.lastAppliedStyle).forEach((key) => {
            ElementStyle.setStyle(textContainerElement, key, '');
        });
    }
    // if this operation turns out to be expensive - try to save and reuse the default style
    // prettier-ignore
    static setDefaultStyle(columnDetails, processedStyle, textContainerElement, columnsSettings, oldCellStyle) {
        ResetColumnStyles.unsetLastAppliedStyle(processedStyle, textContainerElement);
        if (oldCellStyle)
            ElementStyle.unsetStyle(textContainerElement, oldCellStyle);
        CellElement.setDefaultCellStyle(textContainerElement, columnsSettings.cellStyle);
        ColumnSettingsStyleUtils.applySettingsStyleOnCell(columnDetails.settings, textContainerElement, false);
    }
}
//# sourceMappingURL=resetColumnStyles.js.map