import { DEFAULT_COLUMN_TYPES } from '../../enums/defaultColumnTypes';
import { RegexUtils } from '../regex/regexUtils';
export class CalendarFunctionalityUtils {
    static mdYCellTextToYMD(cellText) {
        const integerArr = RegexUtils.extractIntegerStrs(cellText);
        return [integerArr[2], integerArr[0], integerArr[1]];
    }
    static yMDToMDYCellText(YMD) {
        return [YMD[1], YMD[2], YMD[0]].join('-');
    }
    static dMYCellTextToYMD(cellText) {
        const integerArr = RegexUtils.extractIntegerStrs(cellText);
        return [integerArr[2], integerArr[1], integerArr[0]];
    }
    static yMDToDMYCellText(YMD) {
        return [YMD[2], YMD[1], YMD[0]].join('-');
    }
}
CalendarFunctionalityUtils.DEFAULT_TYPES_FUNCTIONALITY = {
    [DEFAULT_COLUMN_TYPES.DATE_DMY]: {
        toYMDFunc: (cellText) => CalendarFunctionalityUtils.dMYCellTextToYMD(cellText),
        fromYMDFunc: (YMD) => CalendarFunctionalityUtils.yMDToDMYCellText(YMD),
    },
    [DEFAULT_COLUMN_TYPES.DATE_MDY]: {
        toYMDFunc: (cellText) => CalendarFunctionalityUtils.mdYCellTextToYMD(cellText),
        fromYMDFunc: (YMD) => CalendarFunctionalityUtils.yMDToMDYCellText(YMD),
    },
};
//# sourceMappingURL=calendarFunctionalityUtils.js.map