import { DEFAULT_COLUMN_TYPES } from '../../enums/defaultColumnTypes';
import { EMPTY_STRING } from '../../consts/text';
export class Validation {
    static setSelectValidation(type, isDefaultTextRemovable, defaultText) {
        var _a, _b, _c;
        if (!((_a = type.cellDropdownProps) === null || _a === void 0 ? void 0 : _a.options) || ((_b = type.cellDropdownProps) === null || _b === void 0 ? void 0 : _b.canAddMoreOptions))
            return;
        const optionsMap = new Set(type.cellDropdownProps.options.map((option) => option.text));
        (_c = type.textValidation) !== null && _c !== void 0 ? _c : (type.textValidation = {});
        type.textValidation.func = (cellText) => {
            return !!optionsMap.has(cellText) || (!isDefaultTextRemovable && cellText === defaultText);
        };
    }
}
Validation.DEFAULT_TYPES_REGEX = {
    [DEFAULT_COLUMN_TYPES.CURRENCY]: new RegExp(
    // eslint-disable-next-line max-len
    /^(([$€£¥]\s*?-?(([1-9]\d{0,2}(,\d{3})*)|\d+)?(\.\d{1,2})?)|(-?(([1-9]\d{0,2}(,\d{3})*)|\d+)?(\.\d{1,2})?\s*?[$€£¥]))$/),
    // \s*? is used to allow spaces between symbols
    [DEFAULT_COLUMN_TYPES.DATE_DMY]: new RegExp(/^(0?[1-9]|[12][0-9]|3[01])\s*?[/-]\s*?(0?[1-9]|1[012])\s*?[/-]\s*?\d{4}$/),
    [DEFAULT_COLUMN_TYPES.DATE_MDY]: new RegExp(/^(0?[1-9]|1[012])\s*?[/-]\s*?(0?[1-9]|[12][0-9]|3[01])\s*?[/-]\s*?\d{4}$/),
};
Validation.DEFAULT_TYPES_FUNCTIONALITY = {
    [DEFAULT_COLUMN_TYPES.NUMBER]: (cellText) => cellText !== EMPTY_STRING && !isNaN(cellText),
    [DEFAULT_COLUMN_TYPES.CURRENCY]: (cellText) => Validation.DEFAULT_TYPES_REGEX[DEFAULT_COLUMN_TYPES.CURRENCY].test(cellText),
    [DEFAULT_COLUMN_TYPES.DATE_DMY]: (cellText) => Validation.DEFAULT_TYPES_REGEX[DEFAULT_COLUMN_TYPES.DATE_DMY].test(cellText),
    [DEFAULT_COLUMN_TYPES.DATE_MDY]: (cellText) => Validation.DEFAULT_TYPES_REGEX[DEFAULT_COLUMN_TYPES.DATE_MDY].test(cellText),
};
//# sourceMappingURL=validation.js.map