import { EMPTY_STRING } from '../../consts/text';
export class InitialContentProcessing {
    static cleanupContentThatDidNotGetAdded(content, columnsDetails) {
        var _a;
        if (((_a = content[0]) === null || _a === void 0 ? void 0 : _a.length) - columnsDetails.length > 0)
            content.forEach((row) => row.splice(columnsDetails.length));
        if (columnsDetails.length === 0) {
            content.splice(0, content.length);
        }
        else if (content.length > columnsDetails[0].elements.length) {
            content.splice(columnsDetails[0].elements.length);
        }
    }
    static postProcess(content, columnsDetails) {
        setTimeout(() => InitialContentProcessing.cleanupContentThatDidNotGetAdded(content, columnsDetails));
    }
    static fillRow(row, maxRowLength) {
        const newArray = new Array(maxRowLength - row.length).fill(EMPTY_STRING);
        row.splice(row.length, maxRowLength - row.length, ...newArray);
    }
    static processRowContentByLength(content, maxRowLength) {
        // if all rows length is 0 - remove them
        if (maxRowLength === 0) {
            content.splice(0, content.length);
        }
        content.forEach((row) => {
            if (row.length < maxRowLength) {
                InitialContentProcessing.fillRow(row, maxRowLength);
            }
        });
    }
    static getMaxRowLength(content) {
        return content.reduce((currentMax, row) => {
            return Math.max(currentMax, row.length);
        }, 0);
    }
    static removeRowsExceedingLimit(content, maxRows) {
        if (maxRows !== undefined && maxRows > 0 && content.length > maxRows) {
            content.splice(maxRows, content.length - 1);
        }
    }
    static removeDuplicateHeaders(content, defaultValue) {
        const headerRow = content[0];
        headerRow.reduce((currentSet, newValue, columnIndex) => {
            if (currentSet.has(newValue)) {
                headerRow[columnIndex] = defaultValue || '';
            }
            else {
                currentSet.add(newValue);
            }
            return currentSet;
        }, new Set());
    }
    static preProcess(at, content) {
        const { maxRows, allowDuplicateHeaders, _defaultColumnsSettings } = at;
        InitialContentProcessing.removeRowsExceedingLimit(content, maxRows);
        const maxRowLength = InitialContentProcessing.getMaxRowLength(content);
        InitialContentProcessing.processRowContentByLength(content, maxRowLength);
        if (!allowDuplicateHeaders && content.length > 0) {
            InitialContentProcessing.removeDuplicateHeaders(content, _defaultColumnsSettings.defaultText);
        }
    }
}
//# sourceMappingURL=initialContentProcessing.js.map