// Purpose of this is to allow to add and remove events that contain bindings
export class ElementEvents {
    static toggleListeners(element, events, isAdd) {
        Object.keys(events).forEach((event) => {
            const eventFuncs = events[event];
            (eventFuncs || []).forEach((eventFunc) => {
                element[isAdd ? 'addEventListener' : 'removeEventListener'](event, eventFunc);
            });
        });
    }
    static convertToArrayObj(nonArr) {
        return Object.keys(nonArr).reduce((obj, eventName) => {
            const key = eventName;
            const func = nonArr[key];
            if (key && func)
                obj[key] = [func];
            return obj;
        }, {});
    }
    static getDefault() {
        return { rootCell: { styles: {} } };
    }
}
//# sourceMappingURL=elementEvents.js.map