import { Browser } from '../browser/browser';
// this class is used to augment the offset by the browser as safari and firefox calculate them differently
// ONLY for elements inside the table
export class ElementOffset {
    static processLeft(offset, borderDimensions) {
        if (Browser.IS_FIREFOX) {
            offset += borderDimensions.leftWidth;
        }
        else if (Browser.IS_SAFARI) {
            offset -= borderDimensions.leftWidth;
        }
        return offset;
    }
    static processTop(offset, borderDimensions) {
        if (Browser.IS_FIREFOX) {
            offset += borderDimensions.topWidth;
        }
        else if (Browser.IS_SAFARI) {
            offset -= borderDimensions.topWidth;
        }
        return offset;
    }
    static processWidth(offset, borderDimensions) {
        if (Browser.IS_FIREFOX)
            offset += borderDimensions.leftWidth;
        return offset;
    }
}
//# sourceMappingURL=elementOffset.js.map