export class ElementSiblingIterator {
    static create(element) {
        let currentElement = element;
        return {
            next: () => {
                const nextSibling = currentElement.nextSibling;
                if (nextSibling) {
                    currentElement = nextSibling;
                }
                return nextSibling;
            },
            currentElement: () => currentElement,
        };
    }
}
//# sourceMappingURL=elementSiblingIterator.js.map