export class ElementStyle {
    static setStyle(element, style, value) {
        element.style[style] = value;
    }
    // prettier-ignore
    static moveStyles(sourceElement, destinationElement, ...styles) {
        styles.forEach((style) => {
            if (sourceElement.style[style]) {
                ElementStyle.setStyle(destinationElement, style, sourceElement.style[style]);
            }
        });
    }
    static unsetStyle(element, style) {
        const unsetStyles = Object.keys(style).reduce((obj, styleName) => {
            obj[styleName] = '';
            return obj;
        }, {});
        Object.assign(element.style, unsetStyles);
    }
    static unsetAllCSSStates(buttonElement, statefulStyle) {
        if (statefulStyle.click)
            ElementStyle.unsetStyle(buttonElement, statefulStyle.click);
        if (statefulStyle.hover)
            ElementStyle.unsetStyle(buttonElement, statefulStyle.hover);
        if (statefulStyle.default)
            ElementStyle.unsetStyle(buttonElement, statefulStyle.default);
    }
    static generateStatefulCSS(styles, defHover, defClick) {
        const defaultStyle = styles.default || {};
        const hoverStyle = Object.assign(JSON.parse(JSON.stringify({ ...defaultStyle, ...defHover })), styles === null || styles === void 0 ? void 0 : styles.hover);
        const clickStyle = Object.assign(JSON.parse(JSON.stringify({ ...hoverStyle, ...defClick })), styles === null || styles === void 0 ? void 0 : styles.click);
        return { default: defaultStyle, hover: hoverStyle, click: clickStyle };
    }
}
//# sourceMappingURL=elementStyle.js.map