import { ColumnDetailsUtils } from '../columnDetails/columnDetailsUtils';
export class FireEvents {
    // prettier-ignore
    static onCellUpdate(at, cellText, rowIndex, columnIndex, updateType) {
        const updateBody = { text: String(cellText), rowIndex, columnIndex, updateType };
        at.onCellUpdate(updateBody);
        at.dispatchEvent(new CustomEvent('cell-update', { detail: updateBody }));
    }
    static onContentUpdate(at) {
        const updateBody = JSON.parse(JSON.stringify(at.content));
        at.onContentUpdate(updateBody);
        at.dispatchEvent(new CustomEvent('content-update', { detail: updateBody }));
    }
    static onColumnsUpdate(at) {
        const updateBody = ColumnDetailsUtils.getAllColumnsDetails(at._columnsDetails);
        at.onColumnsUpdate(updateBody);
        at.dispatchEvent(new CustomEvent('columns-update', { detail: updateBody }));
    }
    static onRender(at) {
        at.onRender();
        at.dispatchEvent(new CustomEvent('render'));
    }
}
//# sourceMappingURL=fireEvents.js.map