import { CheckboxCellElement } from '../../elements/cell/checkboxCell/checkboxCellElement';
import { CellElement } from '../../elements/cell/cellElement';
import { Browser } from '../browser/browser';
export class CaretPosition {
    static setSelectionToEndOfText(textContainerElement, selection) {
        const textElement = CellElement.getTextElement(textContainerElement);
        const range = document.createRange();
        range.setStart(textElement.childNodes[0], CellElement.getText(textElement).length || 0);
        range.collapse(true);
        selection.removeAllRanges();
        selection.addRange(range);
    }
    static getSelection(at) {
        var _a;
        const shadowRoot = at.shadowRoot;
        // chrome
        if (shadowRoot.getSelection) {
            return shadowRoot.getSelection();
        }
        // firefox
        // safari - uses the following but can't pick up the current location
        const windowShadowRoot = (_a = window.document.activeElement) === null || _a === void 0 ? void 0 : _a.shadowRoot;
        if (windowShadowRoot === shadowRoot) {
            return window.document.getSelection();
        }
        return null;
    }
    static setToEndOfText(at, textContainerElement) {
        if (CheckboxCellElement.isCheckboxCell(textContainerElement))
            return;
        let selection = CaretPosition.getSelection(at);
        if (Browser.IS_SAFARI && !selection) {
            textContainerElement.focus();
            selection = CaretPosition.getSelection(at);
        }
        if (selection)
            CaretPosition.setSelectionToEndOfText(textContainerElement, selection);
    }
}
//# sourceMappingURL=caretPosition.js.map