export class FocusedCellUtils {
    static createEmpty() {
        return {};
    }
    static setHeaderCell(focusedCell, cell, columnIndex) {
        focusedCell.element = cell;
        focusedCell.rowIndex = 0;
        focusedCell.columnIndex = columnIndex;
    }
    static setIndexCell(focusedCell, cell, rowIndex) {
        focusedCell.element = cell;
        focusedCell.rowIndex = rowIndex;
        delete focusedCell.columnIndex;
    }
    static set(focusedCell, cellElement, rowIndex, columnIndex) {
        focusedCell.element = cellElement;
        focusedCell.rowIndex = rowIndex;
        focusedCell.columnIndex = columnIndex;
    }
    static incrementColumnIndex(focusedCell, newColumnIndex) {
        if (focusedCell.columnIndex !== undefined && newColumnIndex <= focusedCell.columnIndex) {
            focusedCell.columnIndex += 1;
        }
    }
    static purge(focusedCell) {
        delete focusedCell.columnIndex;
        delete focusedCell.element;
        delete focusedCell.rowIndex;
    }
}
//# sourceMappingURL=focusedCellUtils.js.map