// frame components are comprised of index column, add new column column and add new row row
export class FrameComponentsColors {
    // prettier-ignore
    static getInheritedHeaderColors(at) {
        var _a, _b, _c, _d, _e, _f;
        const { _defaultColumnsSettings: { headerStyles, cellStyle } } = at;
        return {
            default: {
                backgroundColor: ((_a = headerStyles === null || headerStyles === void 0 ? void 0 : headerStyles.default) === null || _a === void 0 ? void 0 : _a.backgroundColor) || (cellStyle === null || cellStyle === void 0 ? void 0 : cellStyle.backgroundColor) || '',
                color: ((_b = headerStyles === null || headerStyles === void 0 ? void 0 : headerStyles.default) === null || _b === void 0 ? void 0 : _b.color) || (cellStyle === null || cellStyle === void 0 ? void 0 : cellStyle.color) || '',
            },
            hover: {
                backgroundColor: ((_c = headerStyles === null || headerStyles === void 0 ? void 0 : headerStyles.hoverColors) === null || _c === void 0 ? void 0 : _c.backgroundColor) || ((_d = headerStyles === null || headerStyles === void 0 ? void 0 : headerStyles.default) === null || _d === void 0 ? void 0 : _d.backgroundColor)
                    || (cellStyle === null || cellStyle === void 0 ? void 0 : cellStyle.backgroundColor) || at._defaultCellHoverColors.backgroundColor,
                color: ((_e = headerStyles === null || headerStyles === void 0 ? void 0 : headerStyles.hoverColors) === null || _e === void 0 ? void 0 : _e.color) || ((_f = headerStyles === null || headerStyles === void 0 ? void 0 : headerStyles.default) === null || _f === void 0 ? void 0 : _f.color)
                    || (cellStyle === null || cellStyle === void 0 ? void 0 : cellStyle.color) || at._defaultCellHoverColors.color,
            },
        };
    }
    // prettier-ignore
    static getHoverColorValue(at, colorKey) {
        var _a, _b, _c;
        const { _frameComponents: { styles }, _defaultCellHoverColors } = at;
        return ((_a = styles === null || styles === void 0 ? void 0 : styles.hoverColors) === null || _a === void 0 ? void 0 : _a[colorKey]) || ((_b = styles === null || styles === void 0 ? void 0 : styles.default) === null || _b === void 0 ? void 0 : _b[colorKey])
            || ((_c = at._defaultColumnsSettings.cellStyle) === null || _c === void 0 ? void 0 : _c[colorKey]) || _defaultCellHoverColors[colorKey];
    }
    static getDefaultColorValue(at, colorKey) {
        var _a, _b, _c;
        return ((_b = (_a = at._frameComponents.styles) === null || _a === void 0 ? void 0 : _a.default) === null || _b === void 0 ? void 0 : _b[colorKey]) || ((_c = at._defaultColumnsSettings.cellStyle) === null || _c === void 0 ? void 0 : _c[colorKey]) || '';
    }
    // prettier-ignore
    static setEventColors(at) {
        const newCellColors = {
            default: {
                backgroundColor: FrameComponentsColors.getDefaultColorValue(at, 'backgroundColor'),
                color: FrameComponentsColors.getDefaultColorValue(at, 'color'),
            },
            hover: {
                backgroundColor: FrameComponentsColors.getHoverColorValue(at, 'backgroundColor'),
                color: FrameComponentsColors.getHoverColorValue(at, 'color'),
            },
        };
        const { _frameComponents: { cellColors, inheritHeaderColors } } = at;
        cellColors.data = newCellColors;
        cellColors.header = inheritHeaderColors ? FrameComponentsColors.getInheritedHeaderColors(at) : newCellColors;
    }
    static getColorsBasedOnParam(cellColors, rowIndex) {
        const { data, header } = cellColors;
        return rowIndex === 0 ? header : data;
    }
    static getDefaultCellColors() {
        return {
            data: {
                default: { backgroundColor: '', color: '' },
                hover: { backgroundColor: '', color: '' },
            },
            header: {
                default: { backgroundColor: '', color: '' },
                hover: { backgroundColor: '', color: '' },
            },
        };
    }
}
//# sourceMappingURL=frameComponentsColors.js.map