import { ColumnSizerGenericUtils } from '../../../elements/columnSizer/utils/columnSizerGenericUtils';
export class UpdateRowElement {
    // required to allow the divider and all its elements to inherit its height (in non chrome or firefox browsers)
    static updateHeaderRowHeight(rowElement) {
        if (!ColumnSizerGenericUtils.canHeightBeInherited()) {
            rowElement.style.height = UpdateRowElement.UNSET; // using unset to get highest cell highet
            rowElement.style.height = getComputedStyle(rowElement).height; // rowElement.offsetHeight doesn't get decimal places
        }
    }
    // if this does not capture all events - use in HeaderText.onAttemptChange method instead
    static updateHeadRowHeightOnKeyDown(tableBody) {
        var _a;
        if (!ColumnSizerGenericUtils.canHeightBeInherited()) {
            const headerRow = (_a = tableBody.children) === null || _a === void 0 ? void 0 : _a[0];
            if (headerRow && headerRow.style.height !== UpdateRowElement.UNSET) {
                headerRow.style.height = UpdateRowElement.UNSET; // using unset to get highest cell highet
                setTimeout(() => {
                    headerRow.style.height = `${headerRow.offsetHeight}px`;
                });
            }
        }
    }
    static getUnsetHeightFunc(rowElement, rowIndex) {
        if (!ColumnSizerGenericUtils.canHeightBeInherited() && rowIndex === 0) {
            return () => (rowElement.style.height = UpdateRowElement.UNSET);
        }
        return undefined;
    }
}
UpdateRowElement.UNSET = 'unset';
//# sourceMappingURL=updateRowElement.js.map