import { FocusedCellUtils } from '../../focusedElements/focusedCellUtils';
export class Drag {
    static move(at, moveByNumber, move) {
        if (moveByNumber === 0)
            return;
        const isMoveDown = moveByNumber > 0;
        const delta = isMoveDown ? 1 : -1;
        for (let i = 0; i < Math.abs(moveByNumber); i += 1) {
            move(at, Drag.ORIGINAL_INDEX + i * delta, isMoveDown);
        }
        // in timeout to allow move to finish processing
        setTimeout(() => FocusedCellUtils.purge(at._focusedElements.cell), 5);
    }
}
Drag.CELL_HIDDEN_CLASS = 'cell-hidden';
Drag.DRAG_PX_TO_MOVE = 10;
Drag.ORIGINAL_INDEX = 0;
//# sourceMappingURL=drag.js.map