import { LITElementTypeConverters } from '../webComponent/LITElementTypeConverters';
export class ObjectUtils {
    static createTwoWayObject(object) {
        Object.keys(object).forEach((key) => {
            object[object[key]] = key;
        });
        return object;
    }
    static convertStringToFunction(object, objectKey) {
        if (typeof object[objectKey] === 'string') {
            object[objectKey] = LITElementTypeConverters.convertToFunction(object[objectKey]);
        }
    }
    // method to check if value is not nullish
    static areValuesFullyDefined(...values) {
        const undefinedValue = values.findIndex((value) => value === undefined || value === null);
        return undefinedValue === -1;
    }
    static removeProperties(object, ...keys) {
        keys.forEach((key) => {
            delete object[key];
        });
    }
}
//# sourceMappingURL=objectUtils.js.map