import { ToggleableElement } from '../../elements/toggleableElement';
import { Dropdown } from '../../../elements/dropdown/dropdown';
import { OuterDropdownElement } from './outerDropdownElement';
export class OuterDropdownButtonEvents {
    static mouseClickButton(at, dropdown, displayFunc) {
        const { element } = dropdown;
        if (element.classList.contains(OuterDropdownButtonEvents.DO_NOT_DISPLAY_DROPDOWN_CLASS)) {
            element.classList.remove(OuterDropdownButtonEvents.DO_NOT_DISPLAY_DROPDOWN_CLASS);
        }
        else {
            displayFunc(at, dropdown);
        }
    }
    static mouseDownButton(dropdown) {
        const { element, button, activeButtonStyle } = dropdown;
        if (Dropdown.isDisplayed(element)) {
            element.classList.add(OuterDropdownButtonEvents.DO_NOT_DISPLAY_DROPDOWN_CLASS);
            ToggleableElement.unsetActive(button, activeButtonStyle);
        }
    }
    static getDisplayFunc(position) {
        if (position.startsWith('top'))
            return OuterDropdownElement.display;
        return OuterDropdownElement.displayReactToBottomVisibility;
    }
    // prettier-ignore
    static set(at, buttonElement, position, dropdown, displayFuncArg) {
        const displayFunc = displayFuncArg || OuterDropdownButtonEvents.getDisplayFunc(position);
        buttonElement.addEventListener('mousedown', OuterDropdownButtonEvents.mouseDownButton.bind(this, dropdown));
        buttonElement.addEventListener('click', OuterDropdownButtonEvents.mouseClickButton.bind(this, at, dropdown, displayFunc));
    }
}
// this is used to prevent the dropdown from opening up again after clicking the button to close
OuterDropdownButtonEvents.DO_NOT_DISPLAY_DROPDOWN_CLASS = 'do-not-display-class';
//# sourceMappingURL=outerDropdownButtonEvents.js.map