import { ARROW_DOWN_SVG_STRING } from '../../../consts/icons/arrowDownIconSVGString';
import { GenericElementUtils } from '../../elements/genericElementUtils';
import { SVGIconUtils } from '../../svgIcons/svgIconUtils';
// this is currently used by file export and rows per page buttons - needs refactoring to include filter
export class OuterDropdownButtonUtils {
    static processStatefulStyle(statefulCSS) {
        var _a, _b;
        (_a = statefulCSS.hover) !== null && _a !== void 0 ? _a : (statefulCSS.hover = statefulCSS.default);
        (_b = statefulCSS.click) !== null && _b !== void 0 ? _b : (statefulCSS.click = statefulCSS.hover);
    }
    static processAndApplyDefaultStyle(element, styles) {
        if (styles) {
            OuterDropdownButtonUtils.processStatefulStyle(styles);
            Object.assign(element.style, styles.default);
        }
    }
    static createArrow(containerClasses, iconClasses) {
        const container = document.createElement('div');
        container.classList.add(OuterDropdownButtonUtils.ARROW_CONTAINER_CLASS, GenericElementUtils.NOT_SELECTABLE_CLASS);
        if (containerClasses)
            container.classList.add(...containerClasses);
        const icon = SVGIconUtils.createSVGElement(ARROW_DOWN_SVG_STRING);
        icon.classList.add(OuterDropdownButtonUtils.ARROW_ICON_CLASS);
        if (iconClasses)
            icon.classList.add(...iconClasses);
        container.appendChild(icon);
        return container;
    }
}
OuterDropdownButtonUtils.ARROW_CONTAINER_CLASS = 'outer-dropdown-button-arrow-container';
OuterDropdownButtonUtils.ARROW_ICON_CLASS = 'outer-dropdown-button-arrow-icon';
//# sourceMappingURL=outerDropdownButtonUtils.js.map