import { DropdownItemHighlightUtils } from '../../color/dropdownItemHighlightUtils';
import { OuterDropdownItem } from './outerDropdownItem';
import { StaticDropdown } from './staticDropdown';
export class OuterDropdownItemEvents {
    // prettier-ignore
    static itemMouseDownCommon(action, hide, event) {
        const { _activeOverlayElements: { outerContainerDropdown } } = this;
        const targetText = event.target.innerText;
        if (!outerContainerDropdown)
            return;
        action === null || action === void 0 ? void 0 : action(this, targetText, event);
        const items = Array.from(outerContainerDropdown.element.children);
        hide === null || hide === void 0 ? void 0 : hide(this._activeOverlayElements, items);
        if (!outerContainerDropdown.element.classList.contains(StaticDropdown.DROPDOWN_CLASS)) {
            OuterDropdownItem.unsetActiveItem(outerContainerDropdown.element);
            OuterDropdownItem.setActive(items, targetText);
            DropdownItemHighlightUtils.fadeCurrentlyHighlighted(this._activeOverlayElements);
        }
    }
}
//# sourceMappingURL=outerDropdownItemEvents.js.map