import { OuterDropdownElement } from './outerDropdownElement';
import { OuterDropdownItem } from './outerDropdownItem';
// this is a utility class that works on top of the outer dropdown files and facilitates functionality for simple
// dropdowns that usually have pre-defined items such as export or rows per page dropdowns
export class OuterDropdownSimpleUtils {
    static hide(activeOverlayElements, dropdownItems) {
        var _a;
        OuterDropdownElement.hide(activeOverlayElements, {});
        const dropdownElement = (_a = activeOverlayElements.outerContainerDropdown) === null || _a === void 0 ? void 0 : _a.element;
        if (dropdownElement) {
            const items = dropdownItems || Array.from(dropdownElement.children);
            OuterDropdownItem.unsetHoverColors(items);
        }
    }
    static getDropdownTopPosition(button) {
        return `${button.offsetTop + button.offsetHeight}px`;
    }
    // this is a custom display function used by dropdowns that do not populate items on display (export, rows per page)
    static display(button, at, dropdown) {
        const { element: dropdownElement } = dropdown;
        dropdownElement.style.bottom = '';
        dropdownElement.style.top = OuterDropdownSimpleUtils.getDropdownTopPosition(button);
        // needs to be displayed here to evalute if in view port
        OuterDropdownElement.displayReactToBottomVisibility(at, dropdown);
    }
}
//# sourceMappingURL=outerDropdownSimpleUtils.js.map