import { CellElement } from '../../../../elements/cell/cellElement';
import { FilterInternalUtils } from './filterInternalUtils';
// REF-42
export class FilterViaTimeouts {
    static processOtherColumnsIfPresent(finish, chunksData, indexes) {
        FilterInternalUtils.ACTIVE_WORKERS -= 1;
        if (chunksData.length > 1 && indexes.length > 0) {
            FilterViaTimeouts.processOtherColumns(finish, chunksData.slice(1), indexes);
        }
        else if (FilterInternalUtils.ACTIVE_WORKERS === 0) {
            finish();
        }
    }
    static toggleRow(cell, chunkData, matchingIndexes, index) {
        const dataText = CellElement.getText(cell);
        const processedText = chunkData.isCaseSensitive ? dataText : dataText.toLocaleLowerCase();
        const doesCellTextContainFilterInput = processedText.includes(chunkData.filterText);
        const row = cell.parentElement;
        if (doesCellTextContainFilterInput) {
            row.classList.remove(FilterInternalUtils.HIDDEN_ROW_CLASS);
            matchingIndexes.push(index);
        }
        else {
            row.classList.add(FilterInternalUtils.HIDDEN_ROW_CLASS);
        }
    }
    static processOtherColumns(finish, chunksData, indexes) {
        setTimeout(() => {
            FilterInternalUtils.ACTIVE_WORKERS += 1;
            const matchingIndexes = [];
            const chunkData = chunksData[0];
            indexes.forEach((index) => {
                const cell = chunkData.chunk[index];
                FilterViaTimeouts.toggleRow(cell, chunkData, matchingIndexes, index);
            });
            FilterViaTimeouts.processOtherColumnsIfPresent(finish, chunksData, matchingIndexes);
        });
    }
    static execute(finish, chunksData) {
        FilterInternalUtils.ACTIVE_WORKERS += 1;
        setTimeout(() => {
            const matchingIndexes = [];
            const chunkData = chunksData[0];
            chunkData.chunk.forEach((cell, index) => {
                FilterViaTimeouts.toggleRow(cell, chunkData, matchingIndexes, index);
            });
            FilterViaTimeouts.processOtherColumnsIfPresent(finish, chunksData, matchingIndexes);
        });
    }
}
//# sourceMappingURL=filterViaTimeouts.js.map