import { FocusedCellUtils } from '../../focusedElements/focusedCellUtils';
import { InsertMatrix } from '../../programmaticUpdates/insertMatrix';
import { ParseCSVClipboardText } from './parseCSVClipboardText';
export class OverwriteCellsViaCSVOnPaste {
    static focusOriginalCellAfterProcess(at, process) {
        const { element, rowIndex, columnIndex } = at._focusedElements.cell;
        process();
        FocusedCellUtils.set(at._focusedElements.cell, element, rowIndex, columnIndex);
    }
    // prettier-ignore
    static overwrite(at, clipboardText, event, rowIndex, columnIndex) {
        event.preventDefault();
        const CSV = ParseCSVClipboardText.parse(clipboardText);
        OverwriteCellsViaCSVOnPaste.focusOriginalCellAfterProcess(at, InsertMatrix.insert.bind(this, at, CSV, rowIndex, columnIndex));
    }
    static isCSVData(clipboardText) {
        return (clipboardText.indexOf(ParseCSVClipboardText.NEW_LINE_SYMBOL) > -1 ||
            clipboardText.indexOf(ParseCSVClipboardText.TAB_SYMBOL) > -1);
    }
}
//# sourceMappingURL=overwriteCellsViaCSVOnPaste.js.map