export class ParseCSVClipboardText {
    static preprocessText(multiLineString) {
        let newString = multiLineString;
        if (multiLineString.charAt(0) === ParseCSVClipboardText.STRING_QUOTE_SYMBOL) {
            newString = newString.substring(1);
        }
        if (multiLineString.charAt(multiLineString.length - 1) === ParseCSVClipboardText.STRING_QUOTE_SYMBOL) {
            newString = newString.substring(0, multiLineString.length - 2);
        }
        return newString;
    }
    static getSeparatorSymbols(multiLineString) {
        // occurs when pasting string that contains actual \n or \t symbols
        if (multiLineString.indexOf(ParseCSVClipboardText.EXPLICIT_NEW_LINE_SYMBOL) > -1 ||
            multiLineString.indexOf(ParseCSVClipboardText.EXPLICIT_TAB_SYMBOL) > -1) {
            return { newLine: ParseCSVClipboardText.EXPLICIT_NEW_LINE_SYMBOL, tab: ParseCSVClipboardText.EXPLICIT_TAB_SYMBOL };
        }
        return { newLine: ParseCSVClipboardText.NEW_LINE_SYMBOL, tab: ParseCSVClipboardText.TAB_SYMBOL };
    }
    static parse(multiLineString) {
        const processedText = ParseCSVClipboardText.preprocessText(multiLineString);
        const { newLine, tab } = ParseCSVClipboardText.getSeparatorSymbols(processedText);
        const linesOfText = processedText.split(newLine);
        return linesOfText.map((lineOfText) => {
            // row indexes in worksheets end with \\t\\t\\t\\t\\t
            return lineOfText.split(tab);
        });
    }
}
ParseCSVClipboardText.STRING_QUOTE_SYMBOL = '"';
ParseCSVClipboardText.TAB_SYMBOL = '\\t';
ParseCSVClipboardText.NEW_LINE_SYMBOL = '\\n';
ParseCSVClipboardText.EXPLICIT_TAB_SYMBOL = '\\\\t';
ParseCSVClipboardText.EXPLICIT_NEW_LINE_SYMBOL = '\\\\n';
//# sourceMappingURL=parseCSVClipboardText.js.map