import { ColumnDropdown } from '../../elements/dropdown/columnDropdown/columnDropdown';
import { ColumnTypesUtils } from '../columnType/columnTypesUtils';
import { CellElement } from '../../elements/cell/cellElement';
import { CellEvents } from '../../elements/cell/cellEvents';
import { Dropdown } from '../../elements/dropdown/dropdown';
import { HeaderText } from '../columnDetails/headerText';
import { ObjectUtils } from '../object/objectUtils';
export class ProgrammaticCellUpdate {
    static updateText(at, programmaticCellUpdate) {
        var _a;
        const { newText, rowIndex, columnIndex } = programmaticCellUpdate;
        if (!ObjectUtils.areValuesFullyDefined(newText, rowIndex, columnIndex))
            return;
        if (typeof newText !== 'string' && typeof newText !== 'number')
            return;
        const element = (_a = at._columnsDetails[columnIndex]) === null || _a === void 0 ? void 0 : _a.elements[rowIndex];
        if (!element || newText === CellElement.getText(element))
            return;
        CellEvents.updateCell(at, newText, rowIndex, columnIndex, { element, processText: rowIndex > 0 });
        ColumnTypesUtils.updateDataElements(at, rowIndex, columnIndex, element);
        if (rowIndex === 0) {
            if (Dropdown.isDisplayed(at._activeOverlayElements.columnDropdown))
                ColumnDropdown.processTextAndHide(at);
            HeaderText.onAttemptChange(at, element, columnIndex);
        }
    }
}
//# sourceMappingURL=programmaticCellUpdate.js.map