import { CellHighlightUtils } from '../color/cellHighlightUtils';
export class StripedRows {
    static setRowStyle(rowElement, index, stripedRows) {
        const style = index % 2 ? stripedRows.even : stripedRows.odd;
        Object.assign(rowElement.style, style);
        return style;
    }
    static process(at) {
        const { stripedRows, _defaultCellHoverColors } = at;
        if (!stripedRows)
            return;
        if (typeof stripedRows === 'boolean') {
            at._stripedRows = StripedRows.DEFAULT_PROPERTIES;
        }
        else {
            at._stripedRows = {
                even: stripedRows.even || StripedRows.DEFAULT_PROPERTIES.even,
                odd: stripedRows.odd || StripedRows.DEFAULT_PROPERTIES.odd,
            };
        }
        CellHighlightUtils.unsetDefaultHoverProperties(_defaultCellHoverColors);
    }
}
StripedRows.DEFAULT_PROPERTIES = {
    odd: { backgroundColor: '' },
    even: { backgroundColor: '#dcdcdc7a' },
};
//# sourceMappingURL=stripedRows.js.map