import { ElementStyle } from '../elements/elementStyle';
export class StickyPropsUtils {
    static process(at) {
        var _a;
        if (typeof at.stickyHeader === 'boolean') {
            at._stickyProps.header = at.stickyHeader;
            // not using _overflow as an indicator as it has yet not been processed
        }
        else if ((_a = at.overflow) === null || _a === void 0 ? void 0 : _a.maxHeight) {
            at._stickyProps.header = true;
        }
    }
    // REF-37
    // prettier-ignore
    static moveTopBorderToHeaderCells(at) {
        const { _tableElementRef, _tableBodyElementRef } = at;
        if (!_tableElementRef || !_tableBodyElementRef)
            return;
        _tableBodyElementRef.classList.add(StickyPropsUtils.NO_OVERFLOW_STICKY_HEADER_BODY_CLASS);
        if (_tableElementRef.style.border) {
            _tableBodyElementRef.style.borderTop = _tableElementRef.style.border;
        }
        if (_tableElementRef.style.borderColor) {
            _tableBodyElementRef.style.borderTopColor = _tableElementRef.style.borderColor;
        }
        ElementStyle.moveStyles(_tableElementRef, _tableBodyElementRef, 'borderTop', 'borderTopColor', 'borderTopWidth', 'borderTopStyle');
        _tableElementRef.style.borderTop = 'unset';
    }
}
// REF-37
StickyPropsUtils.NO_OVERFLOW_STICKY_HEADER_BODY_CLASS = 'no-overflow-sticky-header-body';
//# sourceMappingURL=stickyPropsUtils.js.map