import { FullStringDimension } from '../../types/dimensions';
import { PropertiesOfType } from '../../types/utilityTypes';
import { CSSStyle } from '../../types/cssStyle';
export type PossibleStringDimensions<T> = PropertiesOfType<T, FullStringDimension>;
export type ParsedDimension = {
    number: number;
    isPercentage: boolean;
};
export declare class StringDimensionUtils {
    private static processDimension;
    private static processPercentageDimension;
    static generateNumberDimensionFromClientString<T>(parentElement: HTMLElement, sourceObj: T, dimensionKey: keyof PossibleStringDimensions<T>, isWidth: boolean, minimalDimension?: number): ParsedDimension;
    static removeAllDimensions(style: CSSStyle): Partial<CSSStyleDeclaration> | undefined;
}
//# sourceMappingURL=stringDimensionUtils.d.ts.map