export class WebComponentStyleUtils {
    static add(auxiliaryStyle, shadowRoot) {
        if (!shadowRoot || !auxiliaryStyle)
            return;
        try {
            WebComponentStyleUtils.addStyleSheet(auxiliaryStyle, shadowRoot);
        }
        catch (err) {
            // fallback for if CSSStyleSheet is not supported (Safari)
            WebComponentStyleUtils.addStyleElement(auxiliaryStyle, shadowRoot);
        }
    }
    static addStyleSheet(style, shadowRoot) {
        const styleSheet = new CSSStyleSheet();
        styleSheet.replaceSync(style);
        shadowRoot.adoptedStyleSheets.push(styleSheet);
    }
    static addStyleElement(style, shadowRoot) {
        const stylesDocument = document.createElement('style');
        stylesDocument.innerHTML = style;
        shadowRoot.appendChild(stylesDocument);
    }
}
//# sourceMappingURL=webComponentStyleUtils.js.map